SystemOrganization addCategory: #'Magma server-API'!
SystemOrganization addCategory: #'Magma server-Info'!
SystemOrganization addCategory: #'Magma server-Utilities'!
SystemOrganization addCategory: #'Magma server-private'!

!MaObjectBuffer methodsFor: '*magma server' stamp: 'cmm 1/25/2005 14:58'!
appendGraphNode: oid into: aMaSerializedGraphBuffer using: aMaReadStrategy currentDepth: anInteger minDepth: minDepth with: alreadyAppendedSet filer: aMaObjectFiler

	| buffer |

	(alreadyAppendedSet includes: oid) ifTrue: [ ^self ].
	alreadyAppendedSet add: oid.
	buffer _ aMaObjectFiler
		appendObject: oid
		into: aMaSerializedGraphBuffer.
	buffer
		appendGraphUsing: aMaReadStrategy
		into: aMaSerializedGraphBuffer
		currentDepth: anInteger + 1
		minDepth: minDepth
		with: alreadyAppendedSet
		filer: aMaObjectFiler! !

!MaObjectBuffer methodsFor: '*magma server' stamp: 'cmm 1/25/2005 14:01'!
appendGraphUsing: aMaReadStrategy into: aMaSerializedGraphBuffer currentDepth: currentDepth minDepth: minDepth with: alreadyAppendedSet filer: aMaObjectFiler

	1
		to: self objectInstSize
		do:
			[ :varIndex | | oid |
			(MaOidCalculator isOidForOptimizedObject: (oid _ self maInstVarAt: varIndex))
				ifFalse:
					[ | newMinDepth |
					currentDepth < (
						newMinDepth _
							(aMaReadStrategy
								depthOfAttribute: varIndex
								onClassWithId: self classId
								version: self classVersion) + currentDepth
									max: minDepth)
										ifTrue:
											[ self
												appendGraphNode: oid
												into: aMaSerializedGraphBuffer
												using: aMaReadStrategy
												currentDepth: currentDepth
												minDepth: newMinDepth
												with: alreadyAppendedSet
												filer: aMaObjectFiler ] ] ]
! !

!MaObjectBuffer methodsFor: '*magma server' stamp: 'cmm 7/10/2002 20:02'!
asSentientBuffer
	"Answer the newwwwwww meeee!!  That's right!!  I've been injected
	with the ByteArray-of-truth and now know what kind of buffer
	I always wondered I was going to grow up to be."

	^self class
		createFromByteArray: byteArray
		startPos: startPos
! !

!MaObjectBuffer methodsFor: '*magma server' stamp: 'cmm 10/21/2004 12:49'!
bufferPositionOfBytesToStore
	"Default 1-based position of the byte within each byteArray that we start storing
	to disk at."

	^ 9! !

!MaObjectBuffer methodsFor: '*magma server' stamp: 'cmm 11/24/2004 13:35'!
numberOfBytesToStore
	"Answer the number of bytes that should be stored for this buffer.  This is used by Magma, which doesn't need to store the oid since that is kept in the oid table."

	^self physicalSize - self bufferPositionOfBytesToStore + 1! !

!MaReadStrategy methodsFor: '*magma server' stamp: 'cmm 1/26/2005 12:22'!
depthOfAttribute: attributeIndex onClassWithId: classId version: versionNumber
	"Answer the depth that the attribute at attributeIndex should be traversed into *from the current depth*."

	^depths
		maAt: { classId. versionNumber }
		ifPresent:
			[ :depth |
			depth isInteger
				ifTrue: [ depth ]
				ifFalse: [ depth at: attributeIndex ifAbsent: [ 0 ] ] ]
		ifAbsent: [ 0 ]! !

!MaSerializedGraphBuffer methodsFor: '*magma server' stamp: 'cmm 8/13/2002 21:27'!
decreaseBufferSizeBy: anInteger

	self bufferSize: self bufferSize - anInteger
! !

!MaVariableWordBuffer methodsFor: '*magma server' stamp: 'cmm 1/25/2005 14:07'!
appendGraphUsing: aMaReadStrategy into: aMaSerializedGraphBuffer currentDepth: currentDepth minDepth: minDepth with: alreadyAppendedSet filer: aMaObjectFiler

	"Nothing to do for a variable-word object."! !

!FileStream methodsFor: '*magma server' stamp: 'cmm 7/15/2002 22:58'!
maRead: someNumber bytesFromPosition: bufferPosition of: aByteArray atFilePosition: filePosition

	^self
		position: filePosition;
		next: someNumber
		into: aByteArray
		startingAt: bufferPosition
! !

!FileStream methodsFor: '*magma server' stamp: 'cmm 7/15/2002 22:58'!
maWrite: numberOfBytes bytesFromPosition: bufferPosition of: byteArray atFilePosition: filePosition

	self position: filePosition.
	self
		next: numberOfBytes
		putAll: byteArray
		startingAt: bufferPosition.
	self maMarked: 'performance'.  "is flushing too slow?"
	"self flush"
! !

MaObject subclass: #MaHashIndexRecord
	instanceVariableNames: 'recordNumber lowKey highKey keySize byteArray numberOfEntries entrySize entryWeight canHoldDuplicateKeys'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-private'!

!MaHashIndexRecord commentStamp: '<historical>' prior: 0!
keySize is in bits.
entrySize is in bytes.
!

!MaHashIndexRecord class methodsFor: 'debugging' stamp: 'cmm 3/11/2004 21:04'!
collectionZoomedToward: keyInteger

	| r previousRecord answer |

	answer _ OrderedCollection new.
	r _
		MaHashIndexRecord
			keySize: 64
			numberOfEntries: 30.
	answer add: r.
	previousRecord _ r.
	12 timesRepeat:
		[ answer add: (
			(MaHashIndexRecord
				keySize: 64
				numberOfEntries: 100)
					beZoomedInToward: keyInteger
					from: previousRecord).
		previousRecord _ answer last ].
	^answer
! !

!MaHashIndexRecord class methodsFor: 'creation' stamp: 'cmm 3/11/2004 21:17'!
keySize: numberOfBits numberOfEntries: entrySizeInteger

	^self new
		keySize: numberOfBits
		numberOfEntries: entrySizeInteger ;

		postInitialize! !

!MaHashIndexRecord methodsFor: 'printing' stamp: ''!
allNumberOfChildren
	"This is intended to be used only for printing!!"

	^(self headerSize
		to: byteArray size - 1
		by: entrySize)
			collect: [ :index | self numberOfChildrenAtByteArrayIndex: index ]
! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 3/12/2004 12:09'!
approximateEntryIndexFor: keyInteger
	"Answers the entryIndex for keyInteger that is close but, due to rounding/truncation, may be off by one."

	^ (keyInteger - lowKey) // self entryWeight! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 3/10/2004 01:00'!
atKey: keyInteger put: oidInteger
	"The receiver has been verified for some available slot for keyInteger."

	self
		eligibleByteArrayIndexesFor: keyInteger
		reverseDo:
			[ :index |
			(self hasSlotAvailableAtByteArrayIndex: index)
				ifTrue:
					[ self
						keyAtByteArrayIndex: index
							put: keyInteger;
						oidAtByteArrayIndex: index
							put: oidInteger.
					^index ] ]! !

!MaHashIndexRecord methodsFor: 'debugging' stamp: ''!
baxMap

	| map |

	map _ OrderedCollection new.
	self
		byteArrayIndexesFrom: 0
		do: [ :each | map add: (self entryIndexForBax: each) -> each ].
	^map asArray
! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 3/14/2004 13:41'!
beFrom: lowKeyInteger to: highKeyInteger

	self setLowKey: lowKeyInteger highKey: highKeyInteger.
	self
		lowKey: lowKeyInteger;
		highKey: highKeyInteger
! !

!MaHashIndexRecord methodsFor: 'building' stamp: ''!
beZoomedInToward: keyInteger from: aMaHashIndexRecord
	"Set the receivers low and highIndex to the correct range that can
	accomodate the index where keyInteger belongs in aMaHashIndexRecord."

	| index |

	index _ aMaHashIndexRecord entryIndexFor: keyInteger.
	self
		beFrom: (aMaHashIndexRecord lowestKeyAtIndex: index)
		to: (aMaHashIndexRecord highestKeyAtIndex: index)
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: ''!
bufferSize

	^byteArray size
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: ''!
byteArray

	^byteArray! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 11/22/2002 00:12'!
byteArrayIndexContainingGlobalIndex: anInteger base: baseInteger
	"baseInteger is 0-based."

	| count |

	count _ baseInteger.
	self
		byteArrayIndexesFrom: 0
		do:
			[ :each |
			count _ count + (self numberOfChildrenAtByteArrayIndex: each).
			count >= anInteger ifTrue: [ ^each ] ].
	^nil! !

!MaHashIndexRecord methodsFor: 'private' stamp: ''!
byteArrayIndexFor: entryIndex

	^entryIndex * entrySize + self headerSize
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 11/27/2002 14:55'!
byteArrayIndexOfLowestEntry
	"Answers nil if no entries on this record."

	self
		byteArrayIndexesFrom: 0
		do:
			[ :each | (self hasEntryAtByteArrayIndex: each) ifTrue: [ ^each ] ].
	^nil! !

!MaHashIndexRecord methodsFor: 'actions' stamp: ''!
byteArrayIndexesFrom: startingEntryIndex do: oneArgBlock

	self
		byteArrayIndexesFrom: startingEntryIndex
		to: numberOfEntries - 1
		do: oneArgBlock
! !

!MaHashIndexRecord methodsFor: 'actions' stamp: ''!
byteArrayIndexesFrom: startingEntryIndex to: endingEntryIndex do: oneArgBlock

	(self byteArrayIndexFor: startingEntryIndex)
		to: (self byteArrayIndexFor: endingEntryIndex)
		by: entrySize
		do: oneArgBlock
! !

!MaHashIndexRecord methodsFor: 'testing' stamp: ''!
canAdd: keyInteger

	self
		eligibleByteArrayIndexesFor: keyInteger
		do: [ :index | (self hasSlotAvailableAtByteArrayIndex: index) ifTrue: [ ^true ] ].
	^false
! !

!MaHashIndexRecord methodsFor: 'testing' stamp: ''!
canHoldDuplicateKeys

	^canHoldDuplicateKeys! !

!MaHashIndexRecord methodsFor: 'private' stamp: ''!
clearAllEntries

	self
		byteArrayIndexesFrom: 0
		do: [ :each | self removeEntryAtByteArrayIndex: each ]
! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 12/23/2002 14:42'!
decrementNumberOfChildrenAtByteArrayIndex: anInteger

	| currentNumberOfChildren |

	currentNumberOfChildren _ self numberOfChildrenAtByteArrayIndex: anInteger.
	self
		numberOfChildrenAtByteArrayIndex: anInteger
		put: currentNumberOfChildren - 1! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 11/30/2002 23:51'!
decrementNumberOfChildrenAtKey: keyInteger

	self decrementNumberOfChildrenAtByteArrayIndex: (self highestByteArrayIndexFor: keyInteger)! !

!MaHashIndexRecord methodsFor: 'debugging' stamp: 'cmm 3/9/2004 23:53'!
dumpEntries

	self dumpEntriesTo: Transcript! !

!MaHashIndexRecord methodsFor: 'debugging' stamp: 'cmm 3/10/2004 12:51'!
dumpEntriesTo: aStream

	self 
		byteArrayIndexesFrom: 0
		do:
			[ : eachBax |
			(self numberOfChildrenAtByteArrayIndex: eachBax) > 0
				ifTrue:
					[ | x |
					x _ self entryIndexForBax: eachBax.
					aStream cr; space; space;
						maPrint: 'x:'; maPrint: x;
						maPrint: ' ['; maPrint: (self lowestKeyAtIndex: x); maPrint: '..'; maPrint: (self highestKeyAtIndex: x); maPrint: ']' ;
						maPrint: ' bx:'; maPrint: (self byteArrayIndexFor: x) ;
						maPrint: ' k:'; maPrint: (self keyAtByteArrayIndex: eachBax);
						maPrint: ' o:'; maPrint: (self oidAtByteArrayIndex: eachBax);
						maPrint: ' r:'; maPrint: (self recordNumberAtByteArrayIndex: eachBax);
						maPrint: ' c:'; maPrint: (self numberOfChildrenAtByteArrayIndex: 
eachBax) ] ]! !

!MaHashIndexRecord methodsFor: 'debugging' stamp: 'cmm 3/9/2004 23:56'!
dumpStructureTo: aStream
	self
		maPrintAttributes: #(
			recordNumber lowKey highKey canHoldDuplicateKeys keys recordNumbers oids
			allNumberOfChildren possibleKeys)
		on: aStream! !

!MaHashIndexRecord methodsFor: 'actions' stamp: ''!
eligibleByteArrayIndexesFor: keyInteger do: oneArgBlock

	(self lowestByteArrayIndexFor: keyInteger)
		to: (self highestByteArrayIndexFor: keyInteger)
		by: entrySize
		do: [ :index | oneArgBlock value: index ]
! !

!MaHashIndexRecord methodsFor: 'actions' stamp: 'cmm 3/10/2004 01:00'!
eligibleByteArrayIndexesFor: keyInteger reverseDo: oneArgBlock

	(self highestByteArrayIndexFor: keyInteger)
		to: (self lowestByteArrayIndexFor: keyInteger)
		by: 0-entrySize
		do: [ :index | oneArgBlock value: index ]
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 3/12/2004 12:18'!
entryIndexFor: keyInteger
	"The lowest entry index in which keyInteger can reside."

	| approximate |
	approximate _ self approximateEntryIndexFor: keyInteger.
	^ keyInteger > (self highestKeyAtIndex: approximate)
		ifTrue: [ approximate+1 ]
		ifFalse: [ approximate ]! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: ''!
entryIndexForBax: anInteger
	"Bax means 'byteArrayIndex'."

	^(anInteger - self headerSize) / entrySize
! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 3/12/2004 15:37'!
entryWeight

	^ entryWeight! !

!MaHashIndexRecord methodsFor: 'testing' stamp: ''!
hasChildAtByteArrayIndex: byteArrayIndex

	^(self recordNumberAtByteArrayIndex: byteArrayIndex) > 0
! !

!MaHashIndexRecord methodsFor: 'testing' stamp: 'cmm 12/1/2002 21:44'!
hasChildAtHighestByteArrayIndexForBax: byteArrayIndex

	^(self recordNumberAtHighestByteArrayIndexForBax: byteArrayIndex) > 0! !

!MaHashIndexRecord methodsFor: 'testing' stamp: ''!
hasEntryAtByteArrayIndex: anInteger

	^(self hasSlotAvailableAtByteArrayIndex: anInteger) not
! !

!MaHashIndexRecord methodsFor: 'testing' stamp: ''!
hasEntryForKey: keyInteger
	"Answer whether keyInteger resides in an entry of the receiver."

	self
		eligibleByteArrayIndexesFor: keyInteger
		do:
			[ :index |
			((self hasEntryAtByteArrayIndex: index)
				and: [ (self keyAtByteArrayIndex: index) = keyInteger ])
					ifTrue:
						[ ^true ] ].
	^false
! !

!MaHashIndexRecord methodsFor: 'testing' stamp: ''!
hasSlotAvailableAtByteArrayIndex: anInteger

	^(self oidAtByteArrayIndex: anInteger) = MaOidCalculator specialValueForUnusedHashIndexEntry
! !

!MaHashIndexRecord methodsFor: 'private' stamp: ''!
headerSize
	"Low and high keys.
	^(keySize / 8) * 2  simplified to / 4 for max performance."

	^keySize / 4
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 1/27/2003 23:51'!
highKey

	^byteArray
		maUint: keySize
		at: keySize / 8
! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 1/27/2003 23:57'!
highKey: anInteger

	^byteArray
		maUint: keySize
		at: (keySize / 8)
		put: anInteger
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: ''!
highestByteArrayIndexFor: keyInteger
	"This will vary from the lowestByteArrayIndexFor: keyInteger only when 
	the receiver canHoldDuplicateKeys."

	^self byteArrayIndexFor: (self highestEntryIndexFor: keyInteger)
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 12/1/2002 21:18'!
highestByteArrayIndexForAnyKeyAt: byteArrayIndex
	"this is for records that canHoldDuplicateKeys when we need to find the next child record number, since that is stored at the highestByteArrayIndexFor: that key."

	^self highestByteArrayIndexFor: (self lowestKeyAtIndex: (self entryIndexForBax: byteArrayIndex))! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 3/12/2004 12:50'!
highestEntryIndexFor: keyInteger

	^canHoldDuplicateKeys
		ifTrue:
			[ (self entryIndexFor: keyInteger + 1) - 1 ]
		ifFalse:
			[ self entryIndexFor: keyInteger ]! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 3/12/2004 10:51'!
highestKeyAtIndex: anInteger

	^canHoldDuplicateKeys
		ifTrue:
			[ self lowestKeyAtIndex: anInteger ]
		ifFalse:
			[ (self lowestKeyAtIndex: anInteger + 1) - 1 ]
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 3/11/2004 21:19'!
highestPossibleKey

	^ (2 raisedTo: keySize) - 1! !

!MaHashIndexRecord methodsFor: 'building' stamp: ''!
incrementNumberOfChildrenAtByteArrayIndex: anInteger

	| currentNumberOfChildren |

	currentNumberOfChildren _ self numberOfChildrenAtByteArrayIndex: anInteger.
	self
		numberOfChildrenAtByteArrayIndex: anInteger
		put: currentNumberOfChildren + 1
! !

!MaHashIndexRecord methodsFor: 'copying' stamp: 'cmm 11/1/2002 00:34'!
independentCopy

	^self copyWithAttributes: #('byteArray')! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 1/27/2003 23:51'!
keyAtByteArrayIndex: anInteger

	^byteArray
		maUint: keySize
		at: anInteger + self keyEntryOffset
! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 1/27/2003 23:57'!
keyAtByteArrayIndex: index put: anInteger

	^byteArray
		maUint: keySize
		at: index + self keyEntryOffset
		put: anInteger
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: ''!
keyAtEntryIndex: anInteger

	^self keyAtByteArrayIndex: (self byteArrayIndexFor: anInteger)
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: ''!
keyAtHighestSlotFor: keyInteger

	^self keyAtByteArrayIndex: (self highestByteArrayIndexFor: keyInteger)
! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 12/30/2002 21:40'!
keyEntryOffset

	"^self recordNumberEntryOffset + self sizeOfRecordNumber"

	^12  "<--- same as above, but faster for this performance-critical method."! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 3/11/2004 21:53'!
keySize

	^ keySize! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 11/20/2004 11:18'!
keySize: numberOfBitsInteger numberOfEntries: numberOfEntriesInteger

	keySize _ numberOfBitsInteger.
	numberOfEntries _ numberOfEntriesInteger.
	"Each entry consists of:  value (at: 0), record number (at: 8), key (at: 12), number of child entries (at: 20)."
	entrySize _ self valueSize + self sizeOfRecordNumber + ((keySize / 8) * 2).
	byteArray _ ByteArray new: self headerSize + (entrySize * numberOfEntriesInteger).
	self clearAllEntries! !

!MaHashIndexRecord methodsFor: 'printing' stamp: ''!
keys
	"This is intended to be used only for printing!!"

	^(self headerSize
		to: byteArray size - 1
		by: entrySize)
			collect: [ :index | self keyAtByteArrayIndex: index ]
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 1/27/2003 23:51'!
lowKey

	^byteArray
		maUint: keySize
		at: 0
! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 1/27/2003 23:57'!
lowKey: anInteger

	^byteArray
		maUint: keySize
		at: 0
		put: anInteger
! !

!MaHashIndexRecord methodsFor: 'private' stamp: ''!
lowestByteArrayIndexFor: keyInteger

	^self byteArrayIndexFor: (self entryIndexFor: keyInteger)
! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 3/12/2004 15:29'!
lowestKeyAtIndex: entryIndex
	"Answer the lowest-possible key that can be stored at entryIndex."

	^ lowKey + (entryIndex*self entryWeight) asInteger! !

!MaHashIndexRecord methodsFor: 'printing' stamp: 'cmm 3/12/2004 11:34'!
maPrintAbbreviatedOn: aStream

	self
		maPrintAttributes: #(lowKey highKey entryWeight possibleKeys canHoldDuplicateKeys)
		on: aStream! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: ''!
numberOfChildren

	| total |

	total _ 0.
	self
		byteArrayIndexesFrom: 0
		do: [ :index | total _ total + (self numberOfChildrenAtByteArrayIndex: index) ].
	^total
! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 1/27/2003 23:51'!
numberOfChildrenAtByteArrayIndex: anInteger

	^byteArray
		maUint: keySize
		at: anInteger + self numberOfChildrenEntryOffset
! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 1/27/2003 23:57'!
numberOfChildrenAtByteArrayIndex: index put: anInteger

	^byteArray
		maUint: keySize
		at: index + self numberOfChildrenEntryOffset
		put: anInteger! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 12/6/2002 15:45'!
numberOfChildrenBefore: keyInteger

	| lastByteArrayIndex entryIndex totalInSlotsBeforeKey |

	entryIndex _ self entryIndexFor: keyInteger.
	lastByteArrayIndex _ self byteArrayIndexFor: entryIndex.
	totalInSlotsBeforeKey _ self numberOfChildrenBeforeByteArrayIndex: lastByteArrayIndex.
	^((self keyAtByteArrayIndex: lastByteArrayIndex) < keyInteger
		and: [ self hasEntryAtByteArrayIndex: lastByteArrayIndex ])
			ifTrue:
				[ (lastByteArrayIndex = (self highestByteArrayIndexFor: keyInteger))
					ifTrue: [ totalInSlotsBeforeKey + 1 ]
					ifFalse: [ totalInSlotsBeforeKey + (self numberOfChildrenAtByteArrayIndex: lastByteArrayIndex) ] ]
			ifFalse: [ totalInSlotsBeforeKey ]! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 11/22/2002 00:13'!
numberOfChildrenBeforeByteArrayIndex: anInteger

	| total |

	total _ 0.
	self
		byteArrayIndexesFrom: 0
		do:
			[ :each |
			each = anInteger ifTrue: [ ^total ].
			total _ total + (self numberOfChildrenAtByteArrayIndex: each) ].
	self error: anInteger printString, ' is not a valid byteArrayIndex.'! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 12/30/2002 21:20'!
numberOfChildrenEntryOffset

	^self keyEntryOffset + (keySize / 8)! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: ''!
numberOfEntries

	^numberOfEntries
! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 1/27/2003 23:51'!
oidAtByteArrayIndex: anInteger

	^byteArray 
		maUint: 64
		at: anInteger + self oidEntryOffset
! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 1/27/2003 23:58'!
oidAtByteArrayIndex: index put: anInteger

	^byteArray
		maUint: 64
		at: index + self oidEntryOffset
		put: anInteger
! !

!MaHashIndexRecord methodsFor: 'private' stamp: ''!
oidEntryOffset

	^0
! !

!MaHashIndexRecord methodsFor: 'printing' stamp: ''!
oids
	"This is intended to be used only for printing!!"

	^(self headerSize
		to: byteArray size - 1
		by: entrySize)
			collect: [ :index | self oidAtByteArrayIndex: index ]
! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 3/14/2004 13:43'!
populateFrom: aMaHashIndexRecord

	byteArray
		replaceFrom: 1
		to: byteArray size
		with: aMaHashIndexRecord byteArray.
	recordNumber _ aMaHashIndexRecord recordNumber.
	self 
		setLowKey: aMaHashIndexRecord primLowKey 
		highKey: aMaHashIndexRecord primHighKey! !

!MaHashIndexRecord methodsFor: 'debugging' stamp: ''!
possibleKeys

	| answer |

	answer _ WriteStream on: (String new: numberOfEntries * 2).
	0
		to: numberOfEntries - 1
		do:
			[ :index | | low high |
			low _ self lowestKeyAtIndex: index.
			high _ self highestKeyAtIndex: index.
			answer nextPutAll: ' | '.
			low = high
				ifTrue:
					[ answer maPrint: low ]
				ifFalse:
					[ answer
						maPrint: low;
						maPrint: '..';
						maPrint: high ] ].
	^answer contents
! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 3/11/2004 21:17'!
postInitialize

	self
		beFrom: 0
		to: self highestPossibleKey! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: ''!
primHighKey

	^highKey
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: ''!
primLowKey

	^lowKey
! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 3/14/2004 13:43'!
readFrom: file atPosition: anInteger

	file
		maRead: self bufferSize
		bytesFromPosition: 1
		of: byteArray
		atFilePosition: anInteger.
	self 
		setLowKey: self lowKey
		highKey: self highKey! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: ''!
recordNumber

	^recordNumber! !

!MaHashIndexRecord methodsFor: 'building' stamp: ''!
recordNumber: anInteger

	recordNumber _ anInteger
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 1/27/2003 23:51'!
recordNumberAtByteArrayIndex: anInteger

	^byteArray 
		maUint: 32
		at: anInteger + self recordNumberEntryOffset
! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 1/27/2003 23:58'!
recordNumberAtByteArrayIndex: index put: anInteger

	^byteArray
		maUint: 32
		at: index + self recordNumberEntryOffset
		put: anInteger
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 12/1/2002 20:57'!
recordNumberAtHighestByteArrayIndexForBax: anInteger

	^self recordNumberAtByteArrayIndex: (self highestByteArrayIndexForAnyKeyAt: anInteger)! !

!MaHashIndexRecord methodsFor: 'building' stamp: ''!
recordNumberAtSlotForKey: keyInteger put: recordNumberInteger

	self
		recordNumberAtByteArrayIndex: (self highestByteArrayIndexFor: keyInteger)
		put: recordNumberInteger
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: ''!
recordNumberCloserTo: keyInteger

	^self recordNumberAtByteArrayIndex: (self highestByteArrayIndexFor: keyInteger)
! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 11/20/2004 11:18'!
recordNumberEntryOffset

	^ self valueSize! !

!MaHashIndexRecord methodsFor: 'printing' stamp: ''!
recordNumbers
	"This is intended to be used only for printing!!"

	^(self headerSize
		to: byteArray size - 1
		by: entrySize)
			collect: [ :index | self recordNumberAtByteArrayIndex: index ]
! !

!MaHashIndexRecord methodsFor: 'private' stamp: ''!
removeEntryAtByteArrayIndex: anInteger

	| answer |

	answer _ self oidAtByteArrayIndex: anInteger.
	self
		oidAtByteArrayIndex: anInteger
		put: MaOidCalculator specialValueForUnusedHashIndexEntry.
	^answer
! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 12/5/2002 23:40'!
removeKey: keyInteger withOid: oidInteger

	self
		eligibleByteArrayIndexesFor: keyInteger
		do:
			[ :each |
			((self keyAtByteArrayIndex: each) = keyInteger
				and: [ (self oidAtByteArrayIndex: each) = oidInteger ])
					ifTrue:
						[ self
							removeEntryAtByteArrayIndex: each;
							decrementNumberOfChildrenAtByteArrayIndex: each.
						^each ] ].
	^nil! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 3/14/2004 13:39'!
setLowKey: lowKeyInteger highKey: highKeyInteger

	lowKey _ self lowKey.
	highKey _ self highKey.
	canHoldDuplicateKeys _ (highKey - lowKey + 1) < numberOfEntries.
	entryWeight _ (highKey - lowKey + 1) / numberOfEntries! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 12/30/2002 21:35'!
sizeOfRecordNumber

	^4! !

!MaHashIndexRecord methodsFor: 'debugging' stamp: 'cmm 3/11/2004 21:41'!
structure

	^ String streamContents: [ : stream | self dumpStructureTo: stream ]! !

!MaHashIndexRecord methodsFor: 'private' stamp: 'cmm 11/20/2004 11:17'!
valueSize
	"in bytes."
	^ 8! !

!MaHashIndexRecord methodsFor: 'actions' stamp: 'cmm 1/27/2002 22:46'!
writeTo: file atPosition: anInteger

	file
		maWrite: self bufferSize
		bytesFromPosition: 1
		of: byteArray
		atFilePosition: anInteger
! !

MaObject subclass: #MaHashIndexRecordFactory
	instanceVariableNames: 'index recordNumbersPath entryIndexPath byteArrayIndexPath recordPath preMadeNewRecord'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-private'!

!MaHashIndexRecordFactory class methodsFor: 'creation' stamp: 'cmm 12/4/2002 23:31'!
index: aMaHashIndex

	^self new
		index: aMaHashIndex;
		postInitialize;
		yourself! !

!MaHashIndexRecordFactory methodsFor: 'private initializing' stamp: ''!
createPreMadeNewRecord

	preMadeNewRecord :=
		MaHashIndexRecord
			keySize: index keySize
			numberOfEntries: index hashRecordSize
! !

!MaHashIndexRecordFactory methodsFor: 'accessing' stamp: ''!
entryIndexAtLevel: anInteger

	^entryIndexPath at: anInteger
! !

!MaHashIndexRecordFactory methodsFor: 'private building' stamp: 'cmm 12/4/2002 23:35'!
index: aMaHashIndex

	index := aMaHashIndex! !

!MaHashIndexRecordFactory methodsFor: 'private initializing' stamp: ''!
initializeRecordPathRecords

	1
		to: self maxDepth
		do:
			[ :x |
			recordPath
				at: x
				put: (
					MaHashIndexRecord
						keySize: index keySize
						numberOfEntries: index hashRecordSize) ]
! !

!MaHashIndexRecordFactory methodsFor: 'private accessing' stamp: 'cmm 12/31/2002 14:55'!
maxDepth

	^(index highestPossibleKey log: index numberOfEntries) asInteger! !

!MaHashIndexRecordFactory methodsFor: 'private initializing' stamp: 'cmm 12/4/2002 23:35'!
postInitialize

	recordNumbersPath := OrderedCollection new: self maxDepth.
	entryIndexPath := OrderedCollection new: self maxDepth.
	byteArrayIndexPath := OrderedCollection new: self maxDepth.
	recordPath := Array new: self maxDepth.
	self
		createPreMadeNewRecord;
		initializeRecordPathRecords! !

!MaHashIndexRecordFactory methodsFor: 'accessing' stamp: ''!
preMadeNewRecord

	^preMadeNewRecord! !

!MaHashIndexRecordFactory methodsFor: 'building' stamp: ''!
put: aMaHashIndexRecord atLevel: levelInteger byteArrayIndex: indexInteger

	levelInteger > recordNumbersPath size
		ifTrue:
			[ recordNumbersPath add: aMaHashIndexRecord recordNumber.
			byteArrayIndexPath add: indexInteger.
			entryIndexPath add: (aMaHashIndexRecord entryIndexForBax: indexInteger) ]
		ifFalse:
			[ recordNumbersPath
				at: levelInteger
				put: aMaHashIndexRecord recordNumber.
			byteArrayIndexPath
				at: levelInteger
				put: indexInteger.
			entryIndexPath
				at: levelInteger
				put: (aMaHashIndexRecord entryIndexForBax: indexInteger) ].
	levelInteger > recordPath size
		ifFalse:
			[ (recordPath at: levelInteger) populateFrom: aMaHashIndexRecord ]
! !

!MaHashIndexRecordFactory methodsFor: 'accessing' stamp: 'cmm 11/29/2002 22:47'!
recordAtLevel: levelInteger

	^levelInteger > recordPath size
		ifTrue:
			[ recordPath first independentCopy ]
		ifFalse:
			[ recordPath at: levelInteger ]
! !

!MaHashIndexRecordFactory methodsFor: 'accessing' stamp: ''!
recordNumberAtLevel: anInteger

	^recordNumbersPath at: anInteger
! !

MaObject subclass: #MaLargeCollectionManager
	instanceVariableNames: 'collection memberIndex indexes indexesByAttribute repository lockedBy oidOfIndexesCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-private'!

!MaLargeCollectionManager class methodsFor: 'creation' stamp: ''!
collection: aMagmaCollection repository: aMaObjectRepository oidOfIndexesCollection: anInteger

	^self new
		collection: aMagmaCollection;
		repository: aMaObjectRepository;
		oidOfIndexesCollection: anInteger
! !

!MaLargeCollectionManager methodsFor: 'private actions' stamp: 'cmm 8/22/2002 13:09'!
beLockedBy: aMagmaClientConnection

	lockedBy _ aMagmaClientConnection! !

!MaLargeCollectionManager methodsFor: 'actions' stamp: 'cmm 4/30/2004 00:56'!
close

	memberIndex ifNotNil: [ memberIndex close.  memberIndex _ nil ].
	indexes do: [ :each | each close ].
	self initializeIndexesByAttribute! !

!MaLargeCollectionManager methodsFor: 'private' stamp: ''!
collection: aMagmaCollection

	collection := aMagmaCollection
! !

!MaLargeCollectionManager methodsFor: 'private' stamp: 'cmm 12/2/2004 13:22'!
collectionOid

	^ repository session oidFor: collection! !

!MaLargeCollectionManager methodsFor: 'private' stamp: 'cmm 3/4/2002 22:52'!
createNewIndex: aMaIndexDefinition

	(MaHashIndex
		create: (self fullFileNameStringFor: aMaIndexDefinition)
		keySize: aMaIndexDefinition keySize
		hashRecordSize: aMaIndexDefinition recordSize) close
! !

!MaLargeCollectionManager methodsFor: 'private' stamp: 'cmm 9/24/2004 15:43'!
ensureIndex: aMaIndexDefinition

	(repository directory fileExists:
		(String streamContents:
			[ : stream |
			stream
				nextPutAll: (self filenameComponentFor: aMaIndexDefinition) ;
				nextPut: $. ;
				nextPutAll: MaHashIndex suggestedFileExtension ]))
		ifFalse: 
			[ self createNewIndex: aMaIndexDefinition ]! !

!MaLargeCollectionManager methodsFor: 'private' stamp: 'cmm 10/1/2004 14:43'!
ensureIndexesOpen

	collection indexesDo:
		[ :each |
		(self hasIndexFor: each attribute)
			ifFalse:
				[ indexes add:
					(indexesByAttribute
						at: each attribute
						put: (self openIndex: (self fullFileNameStringFor: each))) ] ]! !

!MaLargeCollectionManager methodsFor: 'private' stamp: 'cmm 12/2/2004 13:14'!
ensureMemberIndexOpen

	memberIndex ifNil:
		[ memberIndex _ self openIndex: (repository collectionFilenameFor: self collectionOid) asString ]! !

!MaLargeCollectionManager methodsFor: 'actions' stamp: 'cmm 4/28/2004 23:50'!
ensureOpen

	^ self 
		ensureMemberIndexOpen ;
		ensureIndexesOpen ;
		yourself! !

!MaLargeCollectionManager methodsFor: 'accessing' stamp: 'cmm 8/22/2002 19:25'!
filename

	^memberIndex filename! !

!MaLargeCollectionManager methodsFor: 'private' stamp: 'cmm 12/2/2004 13:14'!
filenameComponentFor: aMaIndexDefinition

	^ self collectionOid printString , aMaIndexDefinition uniqueFileIdentifier
! !

!MaLargeCollectionManager methodsFor: 'accessing' stamp: 'cmm 9/26/2004 21:07'!
filenames

	^ { self filename }, (indexes collect: [ : each | each filename ])! !

!MaLargeCollectionManager methodsFor: 'private' stamp: 'cmm 9/24/2004 16:24'!
fullFileNameStringFor: aMaIndexDefinition

	^ repository directory fullNameFor:
		(String streamContents:
			[ : stream |
			stream
				nextPutAll: (self filenameComponentFor: aMaIndexDefinition) ;
				nextPut: $. ;
				nextPutAll: MaHashIndex suggestedFileExtension ])! !

!MaLargeCollectionManager methodsFor: 'testing' stamp: 'cmm 4/27/2004 00:34'!
hasIndexFor: attributeSymbol

	^ indexesByAttribute includesKey: attributeSymbol! !

!MaLargeCollectionManager methodsFor: 'private' stamp: 'cmm 7/2/2004 16:09'!
indexForAttribute: aSymbol

	^self
		indexForAttribute: aSymbol
		ifNone:
			[ MagmaEnvironmentError signal:
				'The index for ' , aSymbol ,
					' was not found.  (MaLargeCollectionManager>>#indexForAttribute:).' ]
! !

!MaLargeCollectionManager methodsFor: 'private' stamp: ''!
indexForAttribute: aSymbol ifNone: aBlock

	aSymbol isNil ifTrue: [ ^self memberIndex ].
	^indexesByAttribute
		at: aSymbol
		ifAbsent: aBlock
! !

!MaLargeCollectionManager methodsFor: 'private initializing' stamp: 'cmm 4/30/2004 00:56'!
initialize

	super initialize.
	"we need them mapped to the correct attribute."
	self initializeIndexesByAttribute.
	"and we must know the correct order, as well"
	indexes _ OrderedCollection new! !

!MaLargeCollectionManager methodsFor: 'private initializing' stamp: 'cmm 4/30/2004 00:56'!
initializeIndexesByAttribute

	indexesByAttribute := Dictionary new! !

!MaLargeCollectionManager methodsFor: 'testing' stamp: 'cmm 8/22/2002 12:38'!
isLocked

	^lockedBy ~= nil! !

!MaLargeCollectionManager methodsFor: 'testing' stamp: 'cmm 2/25/2003 10:19'!
isOpen

	^memberIndex ~= nil! !

!MaLargeCollectionManager methodsFor: 'accessing' stamp: 'cmm 8/22/2002 13:00'!
lockedBy
	"Answers a MagmaClientConnection."

	^lockedBy! !

!MaLargeCollectionManager methodsFor: 'accessing' stamp: ''!
memberIndex

	^memberIndex
! !

!MaLargeCollectionManager methodsFor: 'accessing' stamp: ''!
oidOfIndexesCollection

	^oidOfIndexesCollection
! !

!MaLargeCollectionManager methodsFor: 'private building' stamp: ''!
oidOfIndexesCollection: anInteger

	oidOfIndexesCollection := anInteger
! !

!MaLargeCollectionManager methodsFor: 'private' stamp: ''!
openIndex: aString

	^MaHashIndex open: aString
! !

!MaLargeCollectionManager methodsFor: 'actions' stamp: 'cmm 10/1/2004 13:33'!
process: aMaCollectionChanges recordResultsIn: aMaCommitResult

	self
		processLockIn: aMaCollectionChanges
		using: aMaCommitResult connection.
	self processRemovedIndexesIn: aMaCollectionChanges.
	self
		processAddsIn: aMaCollectionChanges
		using: aMaCommitResult.
	self
		processRemovesIn: aMaCollectionChanges;
		processChangedIndexValuesIn: aMaCollectionChanges;
		processAddNewIndexValuesIn: aMaCollectionChanges! !

!MaLargeCollectionManager methodsFor: 'private actions' stamp: 'cmm 12/9/2002 20:17'!
processAddNewIndexValuesIn: aMaCollectionChanges
	"Serialize the new values for an index that is being built."

	aMaCollectionChanges hasNewIndexValues ifFalse: [ ^self ].
	aMaCollectionChanges newIndexValues keysAndValuesDo:
		[ :eachAttribute :eachValues | | index |
		index := (self indexForAttribute: eachAttribute).
		eachValues do:
			[ :eachAssociation |
			eachAssociation key do:
				[ :eachKey |
				index
					add: eachAssociation value
					at: eachKey ] ] ]! !

!MaLargeCollectionManager methodsFor: 'private' stamp: 'cmm 12/2/2004 13:18'!
processAddsIn: aMaCollectionChanges using: aMaCommitResult

	aMaCollectionChanges additionsDo:
		[ :eachOid :eachHashIndexArrays | | addedObjectOid |
		addedObjectOid :=
			(MaOidCalculator isOidForNewObject: eachOid)
				ifTrue:
					[ aMaCommitResult permanentOids at: eachOid ]
				ifFalse:
					[ eachOid ].
		memberIndex
			add: addedObjectOid
			at: addedObjectOid.
		eachHashIndexArrays
			with: indexes
			do:
				[ :eachHashValues :eachIndex |
				eachHashValues do:
					[ :eachHashValue |
					eachIndex
						add: addedObjectOid
						at: eachHashValue ] ] ]! !

!MaLargeCollectionManager methodsFor: 'private' stamp: 'cmm 10/9/2004 18:45'!
processChangedIndexValuesIn: aMaCollectionChanges

	aMaCollectionChanges changedKeySpecificationsDo:
		[ :each | | index |
		index := self indexForAttribute: each attribute.
		"Only remove has values unique to each collection.  Don't waste processing by removing and then adding at the same key."
		each uniqueOldHashValues do:
			[ :eachHashKeyValue | 
			index
				remove: each oid
				at: eachHashKeyValue ].
		each uniqueNewHashValues do:
			[ :eachHashKeyValue |
			index
				add: each oid
				at: eachHashKeyValue ] ]! !

!MaLargeCollectionManager methodsFor: 'private actions' stamp: 'cmm 8/22/2002 13:33'!
processLockIn: aMaCollectionChanges using: aMagmaConnection

	aMaCollectionChanges hasLockSpecified
		ifTrue:
			[ aMaCollectionChanges isLocked
				ifTrue: [ self beLockedBy: aMagmaConnection ]
				ifFalse: [ self beLockedBy: nil ] ]! !

!MaLargeCollectionManager methodsFor: 'private' stamp: ''!
processRemovedIndexesIn: aMaCollectionChanges

	aMaCollectionChanges
		removedIndexesDo: [ :each | self removeIndex: (self indexForAttribute: each) ]
! !

!MaLargeCollectionManager methodsFor: 'private' stamp: 'cmm 12/7/2002 12:12'!
processRemovesIn: aMaLargeCollectionChanges

	aMaLargeCollectionChanges removedDo:
		[ :eachOid :eachHashIndexValuesArray |
		memberIndex
			remove: eachOid
			at: eachOid.
		eachHashIndexValuesArray
			with: indexes
			do:
				[ :eachArray :eachIndex |
				eachArray do:
					[ :eachKeyValue |
					eachIndex
						remove: eachOid
						at: eachKeyValue ] ] ]! !

!MaLargeCollectionManager methodsFor: 'private' stamp: ''!
removeIndex: aMaHashIndex

	aMaHashIndex
		close;
		delete
! !

!MaLargeCollectionManager methodsFor: 'private' stamp: ''!
repository: aMaObjectRepository

	repository := aMaObjectRepository
! !

!MaLargeCollectionManager methodsFor: 'accessing' stamp: ''!
size

	^memberIndex size
! !

!MaLargeCollectionManager methodsFor: 'accessing' stamp: 'cmm 11/20/2002 22:14'!
upTo: anInteger inSegmentFrom: lowKey to: highKey on: attributeSymbol

	| index |
	index _ self indexForAttribute: attributeSymbol.
	^MaSegmentRequestResult new
		lastKnownSize: index size;
		objects:
			(index
				upTo: anInteger
				oidsFrom: lowKey
				to: highKey);
		startIndex:
			(index
				indexOfLowest: lowKey
				exactKey: false);
		indexOfHighestKey: (index indexOfHighest: highKey);
		yourself! !

!MaLargeCollectionManager methodsFor: 'accessing' stamp: 'cmm 11/20/2002 22:28'!
upTo: anInteger inSegmentFromIndex: lowIndex on: attributeSymbol

	| index oids |
	index _ self indexForAttribute: attributeSymbol.
	oids _ 
		index
			upTo: anInteger
			oidsFromIndex: lowIndex.
	^MaSegmentRequestResult new
		lastKnownSize: index size;
		startIndex: lowIndex;
		objects: oids;
		indexOfHighestKey: lowIndex + oids size - 1! !

MaObject subclass: #MaLargeCollectionOfIntegers
	instanceVariableNames: 'file byteSize byteArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-private'!

!MaLargeCollectionOfIntegers commentStamp: 'cmm 2/15/2005 22:38' prior: 0!
As a stand-alone class, I provide the same functionality as a very large OrderedCollection except you can only put in Integers.  And the Integers can only be as large as you specify upon my creation using create:bitSize:.  If you just use create: you get 64 bits, plenty large enough for most practical things.

After creating me, use #open: to open me.  Be sure to #close me when you're done.

You may use #add: or #at:put: to put Integers in me.  You may use !

!MaLargeCollectionOfIntegers class methodsFor: 'utilities' stamp: 'cmm 2/15/2005 22:44'!
create: filenameString

	^self
		create: filenameString
		bitSize: 64
! !

!MaLargeCollectionOfIntegers class methodsFor: 'utilities' stamp: 'cmm 2/15/2005 22:44'!
create: filenameString bitSize: anInteger

	^self new
		byteSize: anInteger / 8;
		create: filenameString
! !

!MaLargeCollectionOfIntegers class methodsFor: 'creation' stamp: ''!
open: aString

	^self new open: aString
! !

!MaLargeCollectionOfIntegers methodsFor: 'accessing' stamp: ''!
add: anInteger

	^self
		at: self size + 1
		put: anInteger
! !

!MaLargeCollectionOfIntegers methodsFor: 'accessing' stamp: 'cmm 10/23/2002 23:08'!
at: logicalIndex ifAbsent: aBlock

	(logicalIndex
		between: 1
		and: self size)
			ifFalse: [ ^aBlock value ].
	file
		maRead: byteSize
		bytesFromPosition: 1
		of: byteArray
		atFilePosition: (self filePositionFor: logicalIndex).
	^self valueInByteArray
! !

!MaLargeCollectionOfIntegers methodsFor: 'accessing' stamp: ''!
at: logicalIndex put: anInteger

	self loadByteArrayWith: anInteger.
	file
		maWrite: byteSize
		bytesFromPosition: 1
		of: byteArray
		atFilePosition: (self filePositionFor: logicalIndex).
	^anInteger
! !

!MaLargeCollectionOfIntegers methodsFor: 'private' stamp: ''!
byteSize: anInteger

	byteSize _ anInteger.
	self initializePremadeByteArray
! !

!MaLargeCollectionOfIntegers methodsFor: 'actions' stamp: 'cmm 3/24/2003 23:40'!
close

	file ifNotNil: [ file closed ifFalse: [ file close ] ]
! !

!MaLargeCollectionOfIntegers methodsFor: 'private' stamp: 'cmm 2/15/2005 22:37'!
create: fileNameString

	file _
		(FileStream concreteStream new
			open: fileNameString
			forWrite: true) binary.
	self
		writeHeader ;
		close! !

!MaLargeCollectionOfIntegers methodsFor: 'private' stamp: ''!
filePositionFor: logicalIndex

	^((logicalIndex - 1) * byteSize) + self headerSize
! !

!MaLargeCollectionOfIntegers methodsFor: 'private' stamp: ''!
headerSize
	"Header consists of:
		number of bits per Integer in the receiver."
	^1
! !

!MaLargeCollectionOfIntegers methodsFor: 'initialize' stamp: 'cmm 1/27/2003 23:51'!
initializeFromHeader: aByteArray

	self byteSize: (
		aByteArray 
			maUint: 8
			at: 0)
! !

!MaLargeCollectionOfIntegers methodsFor: 'initialize' stamp: ''!
initializePremadeByteArray

	byteArray _ ByteArray new: byteSize
! !

!MaLargeCollectionOfIntegers methodsFor: 'private' stamp: 'cmm 1/27/2003 23:58'!
loadByteArrayWith: anInteger

	^byteArray
		maUint: byteSize * 8
		at: 0
		put: anInteger
! !

!MaLargeCollectionOfIntegers methodsFor: 'initialize' stamp: ''!
loadHeader

	| headerBytes |

	headerBytes _ ByteArray new: self headerSize.
	file
		maRead: self headerSize
		bytesFromPosition: 1
		of: headerBytes
		atFilePosition: 0.
	self initializeFromHeader: headerBytes
! !

!MaLargeCollectionOfIntegers methodsFor: 'printing' stamp: 'cmm 2/5/2003 00:25'!
maPrintAbbreviatedOn: aStream

	1
		to: (self size min: 100)
		do:
			[ :each |
			aStream
				space;
				maPrint: (self at: each ifAbsent: [ 'error at: ', each printString ]) ].
	self size > 100 ifTrue: [ aStream nextPutAll: ' ...' ]! !

!MaLargeCollectionOfIntegers methodsFor: 'initialize' stamp: 'cmm 1/27/2003 23:58'!
newHeaderBytes
	"Answer a new ByteArray containing the header for the receiver.
	This is only used when creating the an instance of this class with
	the create: constructor."

	^(ByteArray new: self headerSize)
		maUint: 8
		at: 0
		put: byteSize;
		yourself
! !

!MaLargeCollectionOfIntegers methodsFor: 'private' stamp: 'cmm 2/15/2005 15:23'!
open: fileNameString

	file _ (FileStream concreteStream new
		open: fileNameString
		forWrite: true).
	file ifNil: [ MagmaEnvironmentError signal: fileNameString, ' could not be opened.' ].
	file binary.
	self loadHeader
! !

!MaLargeCollectionOfIntegers methodsFor: 'accessing' stamp: ''!
size

	^(file size - self headerSize) / byteSize! !

!MaLargeCollectionOfIntegers methodsFor: 'private' stamp: 'cmm 1/27/2003 23:51'!
valueInByteArray

	^byteArray
		maUint: byteSize * 8
		at: 0
! !

!MaLargeCollectionOfIntegers methodsFor: 'initialize' stamp: ''!
writeHeader

	| headerBytes |

	headerBytes _ self newHeaderBytes.
	file
		maWrite: self headerSize
		bytesFromPosition: 1
		of: headerBytes
		atFilePosition: 0
! !

MaObject subclass: #MaMagnitudeIndex
	instanceVariableNames: 'file keySize nextRecordNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-private'!

!MaMagnitudeIndex commentStamp: '<historical>' prior: 0!
keySize in bits.!

MaMagnitudeIndex subclass: #MaHashIndex
	instanceVariableNames: 'hashRecordSize record preMadeAnswerArrays recordFactory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-private'!

!MaHashIndex class methodsFor: 'creation' stamp: ''!
create: fileNameString keySize: keySizeInteger

	self shouldNotImplement
! !

!MaHashIndex class methodsFor: 'creation' stamp: ''!
create: fileNameString keySize: numberOfBitsInteger hashRecordSize: entriesInteger

	^self new
		keySize: numberOfBitsInteger;
		hashRecordSize: entriesInteger;
		initializeRecords;
		create: fileNameString
! !

!MaHashIndex class methodsFor: 'creation' stamp: ''!
suggestedFileExtension

	^'hdx'
! !

!MaHashIndex methodsFor: 'add / remove' stamp: 'cmm 3/9/2004 17:00'!
add: oidInteger at: keyInteger
	"Find the record which either has space for keyInteger or is as far zoomed-in as possible (with either space for keyInteger or not).  If a record already contains another key greater than keyInteger, that entry must be 'pushed' down so we can maintain key order.  Additionally, we must incremement the numberOfChildren for each record to the path of where we finally add."

	| currentKeyToWrite currentOidToWrite hasSpace reachedBottom |

	currentKeyToWrite _ keyInteger.
	currentOidToWrite _ oidInteger.
	self selectRoot.
	hasSpace _ false.
	reachedBottom _ false.
	[ hasSpace | reachedBottom ] whileFalse:
		[ | highestBax keyToMove oidToMove childRecordNumber |
		highestBax _ record highestByteArrayIndexFor: currentKeyToWrite.
		((hasSpace _ record canAdd: currentKeyToWrite)
			or: [ (keyToMove _ record keyAtHighestSlotFor: currentKeyToWrite) > currentKeyToWrite ])
				ifTrue:
					[ hasSpace
						ifFalse:
							[ oidToMove _ record oidAtByteArrayIndex: highestBax.
							record removeEntryAtByteArrayIndex: highestBax ].
					"Incrementing here is 'corrected', below, if necessary.."
					record incrementNumberOfChildrenAtByteArrayIndex:
						(record 
							atKey: currentKeyToWrite
							put: currentOidToWrite).
					hasSpace
						ifFalse:
							[ "It should be safe to assume, here, that highestBax is where currentKeyToWrite was just placed."
							(record canAdd: keyToMove)
								ifTrue:
									[ record
										incrementNumberOfChildrenAtByteArrayIndex:
											(record
												atKey: keyToMove
												put: oidToMove);
										decrementNumberOfChildrenAtByteArrayIndex: highestBax.
									hasSpace _ true ]
								ifFalse:
									[ | newBax |
									"If the displaced entry will not be a child of the displacer, we need to correct the increment, (see) above, by decrement the numberOfChildren and incrementing where it *will* be placed."
									newBax _ record highestByteArrayIndexFor: keyToMove.
									highestBax = newBax
										ifFalse:
											[ record
												decrementNumberOfChildrenAtByteArrayIndex: highestBax ;
												incrementNumberOfChildrenAtByteArrayIndex: newBax ] ] ] ]
				ifFalse:
					[ record incrementNumberOfChildrenAtByteArrayIndex: highestBax ].
		self writeRecord: record.
		oidToMove notNil
			ifTrue:
				[
				"we will need to push this key/oid pair down"
				currentKeyToWrite _ keyToMove.
				currentOidToWrite _ oidToMove ].
		childRecordNumber _ record recordNumberCloserTo: currentKeyToWrite.
		reachedBottom _ childRecordNumber = 0.
		reachedBottom ifFalse: [ self selectRecord: childRecordNumber ] ].
	(reachedBottom and: [ hasSpace not ])
		ifTrue:
			[ self selectNewRecordFor: currentKeyToWrite.
			record incrementNumberOfChildrenAtByteArrayIndex:
				(record
					atKey: currentKeyToWrite
					put: currentOidToWrite).
			self writeRecord ]
! !

!MaHashIndex methodsFor: 'private' stamp: ''!
answerArrayOfSize: anInteger

	^anInteger > preMadeAnswerArrays size
		ifTrue:
			[ Array new: anInteger ]
		ifFalse:
			[ preMadeAnswerArrays at: anInteger ]
! !

!MaHashIndex methodsFor: 'private' stamp: ''!
create: fileNameString

	super create: fileNameString.
	self writeNewRoot
! !

!MaHashIndex methodsFor: 'initializing' stamp: ''!
createRecord

	record _
		(MaHashIndexRecord
			keySize: keySize
			numberOfEntries: hashRecordSize)

				beFrom: 0
				to: (2 raisedTo: keySize) - 1;

				recordNumber: 0
! !

!MaHashIndex methodsFor: 'debugging' stamp: 'cmm 10/30/2002 21:03'!
dumpEntries

	self dumpEntriesTo: Transcript! !

!MaHashIndex methodsFor: 'debugging' stamp: 'cmm 11/10/2002 20:31'!
dumpEntriesTo: aStream

	^self
		dumpEntriesTo: aStream
		fromIndex: 0
		count: self size! !

!MaHashIndex methodsFor: 'debugging' stamp: 'cmm 3/3/2004 12:59'!
dumpEntriesTo: aStream fromIndex: fromIndex count: anInteger

	| entryNumber originalRecord stopwatch |

	originalRecord _ record recordNumber.
	entryNumber _ fromIndex.
	stopwatch _ MaStopwatch new start.
	MagmaNotification signal: 'about to dump ', self size printString, ' entries.'.
	aStream endEntry.
	aStream nextPutAll: self filename.
	self
		entriesFrom: fromIndex
		do:
			[ :eachRecord :index :level |
			aStream
				cr;
				nextPutAll: 'at: ' , entryNumber printString;
				tab: level - 1;
				nextPutAll: eachRecord recordNumber printString;
				nextPutAll: ' (' , eachRecord lowKey printString;
				nextPutAll: ' to: ' , eachRecord highKey printString;
				nextPutAll: ')';
				nextPutAll: ' x:' , (eachRecord entryIndexForBax: index) printString;
				nextPutAll: ' k:' , (eachRecord keyAtByteArrayIndex: index) printString;
				nextPutAll: ' o:' , (eachRecord oidAtByteArrayIndex: index) printString;
				nextPutAll: ' r:' , (eachRecord recordNumberAtByteArrayIndex: index) printString;
				nextPutAll: ' c:' , (eachRecord numberOfChildrenAtByteArrayIndex: index) printString.
			entryNumber _ entryNumber + 1.
			stopwatch time > 5 maSeconds ifTrue: [ MagmaNotification signal: entryNumber printString, ' records dumped.'.
			stopwatch reset; start. ] ]
		until: [ :eachRecord :index :level | entryNumber - fromIndex > anInteger ].
	self selectRecord: originalRecord.
	aStream endEntry.
	^aStream! !

!MaHashIndex methodsFor: 'enumerating' stamp: ''!
entriesFrom: keyInteger do: threeArgBlock until: conditionBlock
	"The first two arguments of threeArgBlock and conditionBlock are the record and the
	internal index position needed to access the of each entry in those records via
	keyAtByteArrayIndex:, oidAtByteArrayIndex:, and recordNumberAtByteArrayIndex:.
	The third argument is the levels from the root record, where the root is level 1.
	This is used to reference into the receivers preMadeRecords, a performance optimization."

	^self
		slotsFrom: keyInteger
		do:
			[ :currentRecord :byteArrayIndex :level |
			(currentRecord hasEntryAtByteArrayIndex: byteArrayIndex)
				ifTrue:
					[ threeArgBlock
						value: currentRecord
						value: byteArrayIndex
						value: level ] ]
		until: conditionBlock
! !

!MaHashIndex methodsFor: 'enumerating' stamp: ''!
entriesFromIndex: globalIndex do: threeArgBlock until: conditionBlock

	^self
		slotsFromIndex: globalIndex
		do:
			[ :currentRecord :byteArrayIndex :level |
			(currentRecord hasEntryAtByteArrayIndex: byteArrayIndex)
				ifTrue:
					[ threeArgBlock
						value: currentRecord
						value: byteArrayIndex
						value: level ] ]
		until: conditionBlock
! !

!MaHashIndex methodsFor: 'private' stamp: ''!
filePositionFor: recordNumberInteger

	^self headerSize + (record bufferSize * recordNumberInteger) + 1
! !

!MaHashIndex methodsFor: 'private' stamp: ''!
getNextRecordNumber

	^nextRecordNumber _ nextRecordNumber + 1
! !

!MaHashIndex methodsFor: 'accessing' stamp: ''!
hashRecordSize

	^hashRecordSize! !

!MaHashIndex methodsFor: 'private' stamp: ''!
hashRecordSize: numberOfEntriesInteger

	hashRecordSize _ numberOfEntriesInteger
! !

!MaHashIndex methodsFor: 'private' stamp: ''!
headerSize
	"Header consists of:
		keySize:  16-bits
		recordSize: 16-bits"

	^4
! !

!MaHashIndex methodsFor: 'testing' stamp: ''!
includesKey: anInteger

	self selectFirstRecordWithKeyEqualOrGreaterThan: anInteger.
	^record hasEntryForKey: anInteger
! !

!MaHashIndex methodsFor: 'testing' stamp: ''!
includesOid: oidInteger at: keyInteger

	| hasEntry key |

	self
		entriesFrom: keyInteger
		do:
			[ :eachRecord :eachByteArrayIndex :level |
			(hasEntry and:
				[ key = keyInteger
					and: [ (eachRecord oidAtByteArrayIndex: eachByteArrayIndex) = oidInteger ] ])
						ifTrue:
							[ ^true ] ]
		until:
			[ :eachRecord :eachByteArrayIndex :level |
			"Until we're on an entry that could not possibly hold keyInteger."
			((hasEntry _ eachRecord hasEntryAtByteArrayIndex: eachByteArrayIndex)
				and: [ (key _ eachRecord keyAtByteArrayIndex: eachByteArrayIndex) > keyInteger ])
					or: [ eachByteArrayIndex > (eachRecord highestByteArrayIndexFor: keyInteger) ] ].
	^false
! !

!MaHashIndex methodsFor: 'accessing' stamp: ''!
indexOf: keyInteger

	^self
		indexOfLowest: keyInteger
		exactKey: true
! !

!MaHashIndex methodsFor: 'accessing' stamp: 'cmm 12/3/2002 23:13'!
indexOfHighest: keyInteger
	"If keyInteger is present, answer the index of its last occurrence.
	Otherwise, answer the index of the next lower key.  If keyInteger
	is lower than all keys in the receiver, answer 0."

	| lowestIndexOfNextHigherKey |

	keyInteger >= self highestPossibleKey ifTrue: [ ^self size ].
	lowestIndexOfNextHigherKey _
		self
			indexOfLowest: keyInteger + 1
			exactKey: false.
	lowestIndexOfNextHigherKey = 1 ifTrue: [ ^0 ]. "lower than all"
	^lowestIndexOfNextHigherKey = 0
				ifTrue:
					[ self size ]
				ifFalse:
					[ lowestIndexOfNextHigherKey - 1 max: 1 ]! !

!MaHashIndex methodsFor: 'private' stamp: 'cmm 11/30/2002 13:20'!
indexOfLowest: keyInteger exactKey: aBoolean
	"If aBoolean is true, answer 0 if we don't find an exact key.  If false
	answer the index of the first equal or higher key."

	| total index |

	total _ 0.
	self
		navigateToward: keyInteger
		until:
			[ :currentRecord | | foundRecord |
			foundRecord _ false.
			currentRecord
				eligibleByteArrayIndexesFor: keyInteger
				do:
					[ :each |
					((currentRecord hasEntryAtByteArrayIndex: each)
						and: [ (currentRecord keyAtByteArrayIndex: each) >= keyInteger ])
							ifTrue:
								[ foundRecord _ true ] ].
			total _ total + (record numberOfChildrenBefore: keyInteger).
			foundRecord ]
		do: [ :currentRecord | "nada" ].
	"We now have the correct potential record selected and a correct total number
	of entries that occur before the entry that would contain keyInteger.  Now determine
	whether we should answer it or nil"
	index _ total + 1.
	^aBoolean
		ifTrue:
			[ (record hasEntryForKey: keyInteger) ifTrue: [ ^index ] ifFalse: [ 0 ] ]
		ifFalse:
			[ index > self size ifTrue: [ 0 ] ifFalse: [ index ] ]! !

!MaHashIndex methodsFor: 'initializing' stamp: ''!
initialize

	super initialize.
	self initializePreMadeAnswerArrays
! !

!MaHashIndex methodsFor: 'initializing' stamp: ''!
initializePreMadeAnswerArrays

	preMadeAnswerArrays _ (1 to: 250) collect: [ :eachSize | Array new: eachSize ]
! !

!MaHashIndex methodsFor: 'initializing' stamp: ''!
initializeRecordFactory

	recordFactory _ MaHashIndexRecordFactory index: self
! !

!MaHashIndex methodsFor: 'initializing' stamp: ''!
initializeRecords

	self
		createRecord;
		initializeRecordFactory
! !

!MaHashIndex methodsFor: 'private' stamp: 'cmm 1/27/2003 23:50'!
loadHeaderFrom: aByteArray

	self
		keySize: (aByteArray maUint: 16 at: 0);
		hashRecordSize: (aByteArray maUint: 16 at: 2);
		initializeRecords
! !

!MaHashIndex methodsFor: 'private' stamp: 'cmm 11/27/2002 13:22'!
navigateToward: keyInteger until: untilBlock do: doBlock
	"Select records between the root and the one that can contain keyInteger
	and value one-argument doBlock on each of those records until the
	one-argument untilBlock values true or we cannot navigate any
	closer to keyInteger."

	| level |

	level _ 1.
	self selectRoot.
	[ | goalRecordReached bax |
	bax _ record highestByteArrayIndexFor: keyInteger.
	recordFactory
		put: record
		atLevel: level
		byteArrayIndex: bax.
	goalRecordReached _ untilBlock value: record.
	goalRecordReached not and: 	[ record hasChildAtByteArrayIndex: bax ] ]
		whileTrue:
			[ doBlock value: record.
			self selectRecord: (record recordNumberCloserTo: keyInteger).
			level _ level + 1 ]! !

!MaHashIndex methodsFor: 'private' stamp: 'cmm 12/4/2002 23:30'!
numberOfEntries

	^record numberOfEntries! !

!MaHashIndex methodsFor: 'accessing' stamp: ''!
numberOfEntriesFrom: lowKey to: highKey
	"Inclusive of lowKey and highKey, if those keys exist.
	If lowKey does not exist, we count from the next higher key.
	If highKey doesn't exist, we count up to the next highestKey."

	| lowest |

	(lowest _
		self
			indexOfLowest: lowKey
			exactKey: false) = 0
				ifTrue:
					[ ^0 ].
	^(self indexOfHighest: highKey) - lowest + 1
! !

!MaHashIndex methodsFor: 'accessing' stamp: ''!
occurrencesOf: keyInteger

	^self
		numberOfEntriesFrom: keyInteger
		to: keyInteger
! !

!MaHashIndex methodsFor: 'private' stamp: 'cmm 1/27/2003 23:57'!
populateHeader: aByteArray

	aByteArray
		maUint: 16
		at: 0 
		put: keySize.
	aByteArray
		maUint: 16
		at: 2 
		put: hashRecordSize
! !

!MaHashIndex methodsFor: 'private' stamp: 'cmm 12/25/2002 12:51'!
readHeader

	| header |

	header _ ByteArray new: self headerSize.
	file
		maRead: self headerSize
		bytesFromPosition: 1
		of: header
		atFilePosition: 0.
	self
		loadHeaderFrom: header;
		initializeRecords! !

!MaHashIndex methodsFor: 'private' stamp: ''!
readRecord: aMaHashIndexRecord at: recordIndex

	aMaHashIndexRecord
		readFrom: file
		atPosition: (self filePositionFor: recordIndex);

		recordNumber: recordIndex.
	^aMaHashIndexRecord
! !

!MaHashIndex methodsFor: 'private' stamp: ''!
recordSize

	^record bufferSize
! !

!MaHashIndex methodsFor: 'add / remove' stamp: 'cmm 7/1/2004 10:47'!
remove: oidInteger at: keyInteger
	"Answer a boolean indicating whether anything was removed."

	| currentBaxToFill sourceBax parentRecord childRecord baxFilled |
	(self
		includesOid: oidInteger
		at: keyInteger)
			ifFalse:
				[ ^false ].
	self
		navigateToward: keyInteger
		until:
			[ :eachRecord |
			(currentBaxToFill _ eachRecord
				removeKey: keyInteger
				withOid: oidInteger)
					notNil ]
		do:
			[ :eachRecord |
			eachRecord decrementNumberOfChildrenAtKey: keyInteger.
			self writeRecord ].
	self writeRecord.

	"get out if we can.."
	currentBaxToFill ifNil: [ ^ true ].
	(record hasChildAtByteArrayIndex: currentBaxToFill) ifFalse: [ ^ true ].

	"Now pull up child record entries into the newly vacated slot because add looks for the first available slot that is eligible for the key it is adding, which *could* be greater than the key of the next child (meaning we'd then be out of order)."
	sourceBax _ 0. "non-nil"
	parentRecord _ record independentCopy.
	childRecord _ record independentCopy.
	[ sourceBax notNil and: [ parentRecord hasChildAtHighestByteArrayIndexForBax: currentBaxToFill ] ]
		whileTrue:
			[ | highestByteArrayIndexForBaxToFill |
			highestByteArrayIndexForBaxToFill _ parentRecord highestByteArrayIndexForAnyKeyAt: currentBaxToFill.
			self
				readRecord: childRecord
				at: (parentRecord recordNumberAtByteArrayIndex: highestByteArrayIndexForBaxToFill).
			sourceBax _ childRecord byteArrayIndexOfLowestEntry.
			sourceBax ifNotNil:
				[ baxFilled _ parentRecord
"what if we changed atKey:put: to add to the *highest* rather than lowest possible slot."
					atKey: (childRecord keyAtByteArrayIndex: sourceBax)
					put: (childRecord oidAtByteArrayIndex: sourceBax).
				baxFilled ~= highestByteArrayIndexForBaxToFill
					ifTrue:
						[ parentRecord incrementNumberOfChildrenAtByteArrayIndex: baxFilled.
						parentRecord decrementNumberOfChildrenAtByteArrayIndex: highestByteArrayIndexForBaxToFill ].
				childRecord
					decrementNumberOfChildrenAtByteArrayIndex: sourceBax;
					removeEntryAtByteArrayIndex: sourceBax.
				self
					writeRecord: parentRecord;
					writeRecord: childRecord.
				parentRecord populateFrom: childRecord.
				currentBaxToFill _ sourceBax ] ].
	^true! !

!MaHashIndex methodsFor: 'private' stamp: ''!
selectFirstRecordWithKeyEqualOrGreaterThan: keyInteger
	"If keyInteger is
	larger than every key in the index, answer nil, otherwise answer the level of the
	record with the answer."

	| level searchedLevel |

	level _ 1.
	self
		navigateToward: keyInteger
		until:
			[ :currentRecord |
			currentRecord
				eligibleByteArrayIndexesFor: keyInteger
				do:
					[ :each |
					((currentRecord hasEntryAtByteArrayIndex: each)
						and: [ (currentRecord keyAtByteArrayIndex: each) >= keyInteger ])
							ifTrue:
								[ ^level ] ].
			false ]
		do: [ :currentRecord | level _ level + 1 ].
	"Though we have arrived at the record which would contain keyInteger,
	in case it does not have entries whose keys are >= keyInteger,
	look for the next higher key."
	self
		traverseSlotsFromRecord: record
		index: (record entryIndexFor: keyInteger)
		do: [ :currentRecord :byteArrayIndex :currentLevel | "nothing" ]
		until:
			[ :currentRecord :byteArrayIndex :currentLevel |
			searchedLevel _ currentLevel.
			currentRecord hasEntryAtByteArrayIndex: byteArrayIndex ]
		level: level.
	^searchedLevel
! !

!MaHashIndex methodsFor: 'private' stamp: ''!
selectNewRecordFor: keyInteger
	"We need to make sure we reference the new record from the
	current record."

	self setUpNewRecordFor: keyInteger.
	"Reference new record and write before selecting the new record."
	record
		recordNumberAtSlotForKey: keyInteger
		put: recordFactory preMadeNewRecord recordNumber.
	self
		writeRecord; "replace record that now references newRecord.."
		selectPreMadeNewRecord
! !

!MaHashIndex methodsFor: 'private' stamp: ''!
selectPreMadeNewRecord

	record populateFrom: recordFactory preMadeNewRecord
! !

!MaHashIndex methodsFor: 'private' stamp: ''!
selectRecord: anInteger

	self
		readRecord: record
		at: anInteger
! !

!MaHashIndex methodsFor: 'private' stamp: 'cmm 11/30/2002 13:03'!
selectRecordAt: globalIndex
	"Answer the level and the byteArrayIndex of the selected record, or nil if out of bounds.
	Since the caller of this method is going to call traverseSlotsFromRecord:index:do:until:level:,
	we must be sure to populate the receivers path."

	| level byteArrayIndex currentGlobalPosition outOfBounds |

	self selectRoot.
	level _ 1.
	currentGlobalPosition _ 0.  "0-based"
	outOfBounds _ false.
	[
		byteArrayIndex _
			record
				byteArrayIndexContainingGlobalIndex: globalIndex
				base: currentGlobalPosition.
		byteArrayIndex isNil
			ifTrue:
				[ outOfBounds _ true.
				false ]
			ifFalse:
				[ currentGlobalPosition _
					currentGlobalPosition +
						(record numberOfChildrenBeforeByteArrayIndex: byteArrayIndex).
				(record hasEntryAtByteArrayIndex: byteArrayIndex)
					ifTrue: [ currentGlobalPosition _ currentGlobalPosition + 1 ].
				(currentGlobalPosition < globalIndex) and:
					[ "this should never be false if above is true"
					record hasChildAtByteArrayIndex: byteArrayIndex ] ] ]
						whileTrue:
							[ recordFactory
								put: record
								atLevel: level
								byteArrayIndex: byteArrayIndex.
							self selectRecord:
								(record recordNumberAtByteArrayIndex: byteArrayIndex).
							level _ level + 1 ].
	^outOfBounds
		ifTrue:
			[ nil ]
		ifFalse:
			[ Array
				with: byteArrayIndex
				with: level ]! !

!MaHashIndex methodsFor: 'private' stamp: ''!
selectRoot

	self selectRecord: 0
! !

!MaHashIndex methodsFor: 'private' stamp: ''!
setUpNewRecordFor: keyInteger

	recordFactory preMadeNewRecord
		beZoomedInToward: keyInteger
			from: record;
		recordNumber: self getNextRecordNumber
! !

!MaHashIndex methodsFor: 'accessing' stamp: ''!
size

	self selectRoot.
	^record numberOfChildren
! !

!MaHashIndex methodsFor: 'enumerating' stamp: ''!
slotsFrom: keyInteger do: threeArgBlock until: conditionBlock
	"The first two arguments of threeArgBlock and conditionBlock are the record and the
	internal index position needed to access the of each entry in those records via
	keyAtByteArrayIndex:, oidAtByteArrayIndex:, and recordNumberAtByteArrayIndex:.
	The third argument is the levels from the root record, where the root is level 1.
	This is used to reference into the receivers preMadeRecords, a performance optimization."

	| level startingEntryIndex |

	(level _ self selectFirstRecordWithKeyEqualOrGreaterThan: keyInteger) isNil ifTrue: [ ^self ].
	"For inverted records, it is possible the entryIndex for keyInteger will be consumed by the
	next lower key.  Unfortunately, we have to check."
	startingEntryIndex _ record entryIndexFor: keyInteger.
	(record keyAtEntryIndex: startingEntryIndex) < keyInteger
		ifTrue:
			[ startingEntryIndex _ startingEntryIndex + 1 ].
	self
		traverseSlotsFromRecord: record
		index: startingEntryIndex
		do: threeArgBlock
		until: conditionBlock
		level: level
! !

!MaHashIndex methodsFor: 'enumerating' stamp: ''!
slotsFromIndex: globalIndex do: threeArgBlock until: conditionBlock
	"The first two arguments of threeArgBlock and conditionBlock are the record and the
	internal index position needed to access the of each entry in those records via
	keyAtByteArrayIndex:, oidAtByteArrayIndex:, and recordNumberAtByteArrayIndex:.
	The third argument is the levels from the root record, where the root is level 1.
	This is used to reference into the receivers preMadeRecords, a performance optimization."

	| byteArrayIndexAndLevelArray |

	(byteArrayIndexAndLevelArray _ self selectRecordAt: globalIndex) isNil ifTrue: [ ^self ].
	self
		traverseSlotsFromRecord: record
		index: (record entryIndexForBax: byteArrayIndexAndLevelArray first)
		do: threeArgBlock
		until: conditionBlock
		level: byteArrayIndexAndLevelArray last
! !

!MaHashIndex methodsFor: 'private' stamp: 'cmm 11/29/2002 22:46'!
traverseSlotsFromParentRecord: aMaHashIndexRecord index: entryIndex do: threeArgBlock until: conditionBlock level: levelInteger
	"levelInteger is 1 for the root record."

	| conditionMet |

	conditionMet _ false.
	aMaHashIndexRecord
		byteArrayIndexesFrom: entryIndex
		do:
			[ :index | | nextToRead |
			conditionMet
				ifFalse:
					[ nextToRead _ aMaHashIndexRecord recordNumberAtByteArrayIndex: index.
					(conditionBlock
						value: aMaHashIndexRecord
						value: index
						value: levelInteger)
							ifTrue:
								[ conditionMet _ true ]
							ifFalse:
								[ threeArgBlock
									value: aMaHashIndexRecord
									value: index
									value: levelInteger ] ].
			conditionMet
				ifFalse:
					[ nextToRead > 0
						ifTrue:
							[ | currentRecord |
							currentRecord _ recordFactory recordAtLevel: levelInteger + 1.
							self
								readRecord: currentRecord
								at: nextToRead.
							conditionMet _
								self
									traverseSlotsFromParentRecord: currentRecord
									index: 0
									do: threeArgBlock
									until: conditionBlock
									level: levelInteger + 1 ] ] ].
	^conditionMet
! !

!MaHashIndex methodsFor: 'private' stamp: 'cmm 11/29/2002 22:46'!
traverseSlotsFromRecord: aMaHashIndexRecord index: entryIndex do: threeArgBlock until: conditionBlock level: levelInteger
	"levelInteger is 1 for the root record."

	| done |

	done _
		self
			traverseSlotsFromParentRecord: aMaHashIndexRecord
			index: entryIndex
			do: threeArgBlock
			until: conditionBlock
			level: levelInteger.
	(done not and: [ levelInteger > 1 ])
		ifTrue:
			[ | nextStart |
			nextStart _ recordFactory recordAtLevel: levelInteger - 1.
			self
				readRecord: nextStart
				at: (recordFactory recordNumberAtLevel: levelInteger - 1).
			self
				traverseSlotsFromRecord: nextStart
				index: (recordFactory entryIndexAtLevel: levelInteger - 1) + 1
				do: threeArgBlock
				until: conditionBlock
				level: levelInteger - 1 ]
! !

!MaHashIndex methodsFor: 'accessing' stamp: ''!
upTo: countInteger at: keyInteger

	^self
		upTo: countInteger
		oidsFrom: keyInteger
		to: keyInteger
! !

!MaHashIndex methodsFor: 'accessing' stamp: 'cmm 11/26/2002 22:35'!
upTo: countInteger keysFromIndex: lowIndex

	| result answerIndex |
	result _ self answerArrayOfSize: countInteger.
	answerIndex _ 0.
	self
		entriesFromIndex: lowIndex
		do:
			[ :currentRecord :byteArrayIndex :level |
			result
				at: (answerIndex _ answerIndex + 1)
				put: (currentRecord keyAtByteArrayIndex: byteArrayIndex) ]
		until: [ :currentRecord :index :level | answerIndex = countInteger ].
	^answerIndex = 0
		ifTrue: [ #() ]
		ifFalse:
			[ answerIndex < countInteger
				ifTrue:
					[ result
						copyFrom: 1
						to: answerIndex ]
				ifFalse:
					[ result ] ]! !

!MaHashIndex methodsFor: 'accessing' stamp: ''!
upTo: countInteger oidsFrom: lowKey to: highKey

	| result answerIndex |

	result _ self answerArrayOfSize: countInteger.
	answerIndex _ 1.
	self
		entriesFrom: lowKey
		do:
			[ :currentRecord :byteArrayIndex :level |
			(currentRecord hasEntryAtByteArrayIndex: byteArrayIndex)
				ifTrue:
					[ result
						at: answerIndex
						put: (currentRecord oidAtByteArrayIndex: byteArrayIndex).
					answerIndex _ answerIndex + 1 ] ]
		until:
			[ :currentRecord :byteArrayIndex :level |
			answerIndex > countInteger or:
				[ (currentRecord hasEntryAtByteArrayIndex: byteArrayIndex)
					and: [ (currentRecord keyAtByteArrayIndex: byteArrayIndex) > highKey ] ] ].
	"Need to check in case of a small index (say only 9 entries?)."
	^answerIndex < countInteger
		ifTrue:
			[ result
				copyFrom: 1
				to: answerIndex - 1 ]
		ifFalse:
			[ result ]
! !

!MaHashIndex methodsFor: 'accessing' stamp: 'cmm 11/23/2002 14:10'!
upTo: countInteger oidsFromIndex: lowIndex

	| result answerIndex |
	result _ self answerArrayOfSize: countInteger.
	answerIndex _ 0.
	self
		entriesFromIndex: lowIndex
		do:
			[ :currentRecord :byteArrayIndex :level |
			result
				at: (answerIndex _ answerIndex + 1)
				put: (currentRecord oidAtByteArrayIndex: byteArrayIndex) ]
		until: [ :currentRecord :index :level | answerIndex = countInteger ].
	^answerIndex = 0
		ifTrue: [ #() ]
		ifFalse:
			[ answerIndex < countInteger
				ifTrue:
					[ result
						copyFrom: 1
						to: answerIndex ]
				ifFalse:
					[ result ] ]! !

!MaHashIndex methodsFor: 'private' stamp: ''!
writeHeader

	| header |

	header _ ByteArray new: self headerSize.
	self populateHeader: header.
	file
		maWrite: self headerSize
		bytesFromPosition: 1
		of: header
		atFilePosition: 0
! !

!MaHashIndex methodsFor: 'private' stamp: ''!
writeNewRoot

	self writeRecord
! !

!MaHashIndex methodsFor: 'private' stamp: ''!
writeRecord

	self writeRecord: record
! !

!MaHashIndex methodsFor: 'private' stamp: 'cmm 11/17/2002 22:45'!
writeRecord: aMaHashIndexRecord

	aMaHashIndexRecord
		writeTo: file
		atPosition: (self filePositionFor: aMaHashIndexRecord recordNumber)! !

!MaMagnitudeIndex class methodsFor: 'creation' stamp: ''!
create: aString keySize: numberOfBitsInteger

	^self new
		keySize: numberOfBitsInteger;
		create: aString
! !

!MaMagnitudeIndex class methodsFor: 'creation' stamp: ''!
open: fileNameString

	^self new open: fileNameString
! !

!MaMagnitudeIndex methodsFor: 'building' stamp: ''!
add: oidInteger at: keyInteger

	self subclassResponsibility
! !

!MaMagnitudeIndex methodsFor: 'actions' stamp: 'cmm 3/6/2003 21:42'!
close

	file ifNotNil: [ file closed ifFalse: [ file close ] ]
! !

!MaMagnitudeIndex methodsFor: 'private actions' stamp: 'cmm 5/1/2002 23:16'!
create: fileNameString

	(FileStream concreteStream isAFileNamed: fileNameString)
		ifTrue:
			[ MagmaUserError signal: fileNameString, ' already exists.' ].
	file _
		(FileStream concreteStream new
			open: fileNameString
			forWrite: true) binary.
	self writeHeader.
	nextRecordNumber _ 0
! !

!MaMagnitudeIndex methodsFor: 'actions' stamp: 'cmm 11/26/2002 21:12'!
delete

	file closed ifFalse: [ file close ].
	(FileDirectory forFileName: file name) deleteFileNamed: file name! !

!MaMagnitudeIndex methodsFor: 'accessing' stamp: 'cmm 8/22/2002 19:27'!
filename

	^file name! !

!MaMagnitudeIndex methodsFor: 'private accessing' stamp: ''!
headerSize

	self subclassResponsibility
! !

!MaMagnitudeIndex methodsFor: 'accessing' stamp: ''!
highestPossibleKey

	^(2 raisedTo: keySize) - 1
! !

!MaMagnitudeIndex methodsFor: 'accessing' stamp: ''!
keySize

	^keySize! !

!MaMagnitudeIndex methodsFor: 'private building' stamp: ''!
keySize: numberOfBitsInteger

	keySize _ numberOfBitsInteger
! !

!MaMagnitudeIndex methodsFor: 'accessing' stamp: ''!
lowestPossibleKey

	^0
! !

!MaMagnitudeIndex methodsFor: 'private actions' stamp: 'cmm 10/31/2002 19:37'!
open

	self open: self filename! !

!MaMagnitudeIndex methodsFor: 'private actions' stamp: 'cmm 2/15/2005 15:22'!
open: fileNameString

	(FileStream concreteStream isAFileNamed: fileNameString)
		ifFalse:
			[ MagmaEnvironmentError signal: 'Could not locate index file ', fileNameString ].
	file _
		(FileStream concreteStream new
			open: fileNameString
			forWrite: true).
	file ifNil: [ MagmaEnvironmentError signal: fileNameString, ' could not be opened.' ].
	file binary.
	self readHeader.
	nextRecordNumber _ (file size - self headerSize - 1) / self recordSize.
	nextRecordNumber isInteger
		ifFalse:
			[ MagmaSoftwareError signal: 'Invalid index size.  Requires maintenance tool.' ].
	^self! !

!MaMagnitudeIndex methodsFor: 'private framework' stamp: ''!
readHeader
	"Answer a ByteArray containing the header bytes.  This includes the keySize as well
	as other implementation-specific variables."

	self subclassResponsibility
! !

!MaMagnitudeIndex methodsFor: 'private accessing' stamp: ''!
recordSize

	self subclassResponsibility
! !

!MaMagnitudeIndex methodsFor: 'framework' stamp: 'cmm 12/23/2002 22:16'!
size

	self subclassResponsibility! !

!MaMagnitudeIndex methodsFor: 'framework' stamp: 'cmm 12/23/2002 22:15'!
upTo: countInteger oidsFrom: lowKey to: highKey

	self subclassResponsibility! !

!MaMagnitudeIndex methodsFor: 'private building' stamp: ''!
writeHeader
	"Your keySize should be stored somewhere in the header."

	self subclassResponsibility
! !

MaObject subclass: #MaObjectFiler
	instanceVariableNames: 'directory file preMadeObjectBuffer filePositionIndex usedByteArrays primitiveAttributeAddressesMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-private'!

!MaObjectFiler class methodsFor: 'creation' stamp: 'cmm 9/24/2004 12:52'!
create: aFileDirectory

	^ self new create: aFileDirectory! !

!MaObjectFiler class methodsFor: 'accessing' stamp: 'cmm 9/24/2004 13:01'!
objectPointersFilename

	^ 'objects.idx'! !

!MaObjectFiler class methodsFor: 'accessing' stamp: 'cmm 9/24/2004 13:01'!
objectsFilename

	^ 'objects.magma'! !

!MaObjectFiler class methodsFor: 'creation' stamp: 'cmm 9/24/2004 13:10'!
open: aFileDirectory

	^ self new
		directory: aFileDirectory ;
		open! !

!MaObjectFiler class methodsFor: 'accessing' stamp: ''!
sizeOfEmptyRepository
	"Answer in bytes."

	^1024
! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:38'!
anchorOid

	^ self primitiveAttributeAt: 'anchorOid'! !

!MaObjectFiler methodsFor: 'building' stamp: 'cmm 12/2/2004 13:38'!
anchorOid: anInteger

	^ self
		primitiveAttributeAt: 'anchorOid'
		put: anInteger! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 11/24/2004 15:33'!
append: aMaObjectBuffer to: aMaSerializedGraphBuffer withDataAt: filePositionInteger

	| startPos |

	startPos _ aMaSerializedGraphBuffer bufferSize.
	self
		ensureByteArrayIn: aMaObjectBuffer
		and: aMaSerializedGraphBuffer
		canAccomodate: self trackSize + aMaObjectBuffer bufferPositionOfBytesToStore
		bytesFrom: startPos + 1.
	aMaSerializedGraphBuffer increaseBufferSizeBy:
		(self
			read: self trackSize
			bytesInto: aMaObjectBuffer
			and: aMaSerializedGraphBuffer
			startingAt: startPos
			filePosition: filePositionInteger)! !

!MaObjectFiler methodsFor: 'actions' stamp: 'cmm 1/25/2005 14:10'!
appendObject: oidInteger into: aMaSerializedGraphBuffer
	"Read a single object into aMaSerializedGraphBuffer and adjust its bufferSize accordingly."

	| buffer |
	preMadeObjectBuffer
		byteArray: aMaSerializedGraphBuffer byteArray;
		startPos: aMaSerializedGraphBuffer bufferSize.
	self
		append: preMadeObjectBuffer
		to: aMaSerializedGraphBuffer
		withDataAt: (self filePointerForOid: oidInteger).
	buffer _ preMadeObjectBuffer asSentientBuffer.
	"Set oid only after append because that is where the need for growth is checked."
	buffer oid: oidInteger.
	^buffer
! !

!MaObjectFiler methodsFor: 'debugging' stamp: 'cmm 10/21/2002 21:47'!
bufferFor: oidInteger

	| buffer |
	buffer _ MaSerializedGraphBuffer new: 1000.
	self
		appendObject: oidInteger
		into: buffer.
	^buffer buffers first! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:40'!
classDefinitionsOid

	^self primitiveAttributeAt: 'classDefinitionsOid'
! !

!MaObjectFiler methodsFor: 'building' stamp: 'cmm 12/2/2004 13:40'!
classDefinitionsOid: anInteger

	self
		primitiveAttributeAt: 'classDefinitionsOid'
		put: anInteger
! !

!MaObjectFiler methodsFor: 'actions' stamp: 'cmm 9/24/2004 13:22'!
close

	file ifNotNil:
		[ file closed ifFalse: [ file close ].
		file _ nil ].
	filePositionIndex ifNotNil:
		[ filePositionIndex close.
		filePositionIndex _ nil ]! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 9/24/2004 16:42'!
create: aFileDirectory

	self
		directory: aFileDirectory assureExistence ;
		createDataFile ;
		createFilePositionIndex.
	^ self! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 2/15/2005 13:44'!
createDataFile

	(directory fileExists: self class objectsFilename)
		ifTrue:
			[ MagmaUserError signal: self dataFileName, ' already exists.' ].
	self openObjectsFile.
	file
		next: self class sizeOfEmptyRepository
		putAll: (ByteArray new: self class sizeOfEmptyRepository)
		startingAt: 1.
	self
		classDefinitionsOid: MaOidCalculator oidForNil;
		definitionOid: MaOidCalculator oidForNil;
		signature: MaObjectRepository recognitionSignature;
		version: MagmaSession magmaVersion! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 2/15/2005 22:36'!
createFilePositionIndex

	filePositionIndex _
		MaLargeCollectionOfIntegers
			create: self filePositionIndexFileName
			bitSize: 64.
	filePositionIndex open: self filePositionIndexFileName! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 9/24/2004 13:02'!
dataFileName

	^ directory fullNameFor: self class objectsFilename! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:42'!
definitionOid

	^ self primitiveAttributeAt: 'definitionOid'! !

!MaObjectFiler methodsFor: 'building' stamp: 'cmm 12/2/2004 13:42'!
definitionOid: anInteger

	^self
		primitiveAttributeAt: 'definitionOid'
		put: anInteger
! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 9/26/2004 20:25'!
directory
	^ directory! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 9/24/2004 12:55'!
directory: aFileDirectory

	directory _ aFileDirectory! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 12/30/2002 17:28'!
ensureByteArrayIn: aMaObjectBuffer and: aMaSerializedGraphBuffer canAccomodate: anInteger bytesFrom: startPos

	(startPos + anInteger) > aMaObjectBuffer byteArray size
		ifTrue:
			[ | bigByteArray beforeSize afterSize |
			beforeSize _ aMaObjectBuffer byteArray size.
			afterSize _ (aMaObjectBuffer byteArray size * 2) max: startPos + anInteger.
			bigByteArray _ ByteArray new: afterSize.
			bigByteArray
				replaceFrom: 1
				to: beforeSize
				with: aMaSerializedGraphBuffer byteArray
				startingAt: 1.
			aMaObjectBuffer byteArray: bigByteArray.
			aMaSerializedGraphBuffer byteArray: bigByteArray ]! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 3/1/2005 17:36'!
filePointerForOid: oidInteger

	| answer |
	answer _ filePositionIndex 
		at: (MaOidCalculator indexPositionForOid: oidInteger)
		ifAbsent: [ MagmaInvalidOid signal: oidInteger printString, ' is not a valid oid.' ].
	answer = 0 ifTrue: [ MagmaInvalidOid signal: oidInteger printString, ' is not a valid oid.' ].
	^ answer! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 9/24/2004 13:07'!
filePositionIndexFileName

	^ directory fullNameFor: self class objectPointersFilename! !

!MaObjectFiler methodsFor: 'actions' stamp: ''!
finalize

	self close
! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:32'!
getNextOid

	^MaOidCalculator oidForFilePositionIndexPosition: filePositionIndex size + 1! !

!MaObjectFiler methodsFor: 'actions' stamp: 'cmm 12/2/2004 13:45'!
index: oidInteger at: filePositionInteger

	^filePositionIndex
		at: (MaOidCalculator indexPositionForOid: oidInteger)
		put: filePositionInteger! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 10/21/2004 12:53'!
initialize

	super initialize.
	preMadeObjectBuffer _ MaObjectBuffer new.
	usedByteArrays _ (1 to: 8) collect: [ :each | ByteArray new: each ].
	self initializePrimitiveAttributeAddressesMap! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 12/29/2004 00:22'!
initializePrimitiveAttributeAddressesMap

	primitiveAttributeAddressesMap _ Dictionary new
		at: 'signature' put: (Association key: 0 value: 64);
		at: 0 put: 'signature';

		at: 'version' put: (Association key: 8 value: 16);
		at: 2 put: 'version';

		at: 'booleanFlags' put: (Association key: 10 value: 8);
		at: 10 put: 'booleanFlags';

		at: 'definitionOid' put: (Association key: 11 value: 64);
		at: 11 put: 'definitionOid';

		"gap 19-26"
		at: 'classDefinitionsOid' put: (Association key: 27 value: 64);
		at: 27 put: 'classDefinitionsOid';

		at: 'anchorOid' put: (Association key: 43 value: 64);
		at: 43 put: 'anchorOid';

		yourself! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 5/1/2003 17:37'!
isOpen

	^file notNil and: [ file closed not ]! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 4/21/2003 16:29'!
objectFileSize

	^file size! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 2/15/2005 13:44'!
open

	(directory fileExists: self class objectsFilename)
		ifFalse:
			[ MagmaUserError signal: self dataFileName, ' not found.' ].
	self openObjectsFile.
	[ self validateSignature ] ifCurtailed: [ self close ].
	[ self validateVersion ] ifCurtailed: [ self close ].
	filePositionIndex _
		[ MaLargeCollectionOfIntegers open: self filePositionIndexFileName ] ifCurtailed: [ self close ].
	^ self! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 2/15/2005 13:44'!
openObjectsFile

	file _ directory fileNamed: self class objectsFilename.
	file
		ifNil: [ MagmaUserError signal: 'Could not open files in ', directory pathName ]
		ifNotNil: [ file binary ]! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 10/21/2004 23:00'!
physicalSizeOfObjectAt: filePointer
	"Used to determine how much space we can deallocate from my 'memory' because an object, most likely an OrderedCollection, residing at filePointer has grown and needs to be relocated."

	| byteArray buffer |

	byteArray _ ByteArray new: MaObjectBuffer headerSize.
	buffer _
		MaObjectBuffer
			byteArray: byteArray
			startPos: 0.
	file
		maRead: byteArray size - buffer bufferPositionOfBytesToStore + 1
		bytesFromPosition: buffer bufferPositionOfBytesToStore
		of: byteArray
		atFilePosition: filePointer.
	^ buffer physicalSize! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 12/30/2002 21:15'!
primitiveAttributeAddressesMap

	^primitiveAttributeAddressesMap! !

!MaObjectFiler methodsFor: 'accessing' stamp: ''!
primitiveAttributeAt: aString

	| assoc |

	^self
		uint: (assoc _ self primitiveAttributeAddressesMap at: aString) value
		at: assoc key
! !

!MaObjectFiler methodsFor: 'private' stamp: ''!
primitiveAttributeAt: aString put: anInteger

	| assoc |

	self
		uint: (assoc _ self primitiveAttributeAddressesMap at: aString) value
		at: assoc key
		put: anInteger
! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 9/24/2004 13:21'!
read: numberOfBytes bytesInto: aMaObjectBuffer and: aMaSerializedGraphBuffer startingAt: startPos filePosition: anInteger
	"startPos is 0-based, answer the physicalSize of the buffer read."

	| physicalSize |

	file
		maRead: numberOfBytes
		bytesFromPosition: startPos + aMaObjectBuffer bufferPositionOfBytesToStore
		of: aMaObjectBuffer byteArray
		atFilePosition: anInteger.
	"See if we have read enough, if not read the rest of the buffer."
	(physicalSize _ aMaObjectBuffer physicalSize) > numberOfBytes
		ifTrue:
			[ self
				ensureByteArrayIn: aMaObjectBuffer
				and: aMaSerializedGraphBuffer
				canAccomodate: physicalSize
				bytesFrom: startPos + aMaObjectBuffer bufferPositionOfBytesToStore.
			file
				next: physicalSize - numberOfBytes
				into: aMaSerializedGraphBuffer byteArray
				startingAt: startPos + numberOfBytes + aMaObjectBuffer bufferPositionOfBytesToStore ].
	^physicalSize! !

!MaObjectFiler methodsFor: 'accessing' stamp: ''!
signature

	^self primitiveAttributeAt: 'signature'
! !

!MaObjectFiler methodsFor: 'private' stamp: ''!
signature: anInteger

	self
		primitiveAttributeAt: 'signature'
		put: anInteger
! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 8/12/2002 23:48'!
trackSize
	"This is the minimum number of bytes to read from disk for any object.
	This particular value allows up to 32 instVars to be read at once."

	"^MaAbstractObjectBuffer addressSize * 32 + MaNormalObjectBuffer headerSize"
	^280 "same as above, but faster.."! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 9/24/2004 13:22'!
uint: bits at: anInteger

	| address bytes |

	address _ self usedByteArray: (bytes _ bits / 8).
	file
		maRead: bytes
		bytesFromPosition: 1
		of: address
		atFilePosition: anInteger.
	^address
		maUint: bits
		at: 0
! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 9/24/2004 13:22'!
uint: bits at: filePointer put: anInteger

	| ba bytes |

	ba _ self usedByteArray: (bytes _ bits / 8).
	ba
		maUint: bits
		at: 0
		put: anInteger.
	file
		maWrite: bytes
		bytesFromPosition: 1
		of: ba
		atFilePosition: filePointer
! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 7/16/2002 00:08'!
usedByteArray: size

	^usedByteArrays at: size
! !

!MaObjectFiler methodsFor: 'actions' stamp: 'cmm 7/16/2002 00:01'!
validateSignature

	self signature = MaObjectRepository recognitionSignature
		ifFalse:
			[ MagmaUserError signal: 'This does not appear to be a Magma database.' ]
! !

!MaObjectFiler methodsFor: 'actions' stamp: 'cmm 7/16/2002 21:55'!
validateVersion

	self version = MagmaSession magmaVersion
		ifFalse:
			[ MagmaUserError signal: 'This database requires code version ', self version printString, '.  You are running version ', MagmaSession magmaVersion printString ]! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 7/16/2002 21:53'!
version

	^self primitiveAttributeAt: 'version'! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 7/16/2002 21:53'!
version: anInteger

	self
		primitiveAttributeAt: 'version'
		put: anInteger
! !

!MaObjectFiler methodsFor: 'private' stamp: 'cmm 1/19/2005 15:40'!
write: aMaObjectBuffer at: filePosition
	"Note that the oid is stored in the filePositionsIndex, so there is no need to store it in the data file too.  The oid is the first 8-bytes of the buffer."

	file
		maWrite: aMaObjectBuffer numberOfBytesToStore
		bytesFromPosition:
			aMaObjectBuffer startPos + aMaObjectBuffer bufferPositionOfBytesToStore
		of: aMaObjectBuffer byteArray
		atFilePosition: filePosition! !

!MaObjectFiler methodsFor: 'actions' stamp: 'cmm 12/2/2004 13:45'!
write: aMaObjectBuffer index: aBoolean
	"write a single object encapsulated by aMaObjectBuffer."

	| filePosition |
	filePosition _
		aBoolean
			ifTrue:
				[ self
					index: aMaObjectBuffer oid
					at: file size ]
			ifFalse:
				[ | pos |
				pos _ self filePointerForOid: aMaObjectBuffer oid.
				(self physicalSizeOfObjectAt: pos) < aMaObjectBuffer physicalSize
					ifTrue: [ self index: aMaObjectBuffer oid at: file size ]
					ifFalse: [ pos ] ].
	self
		write: aMaObjectBuffer
		at: filePosition! !

MaObject subclass: #MaObjectRepository
	instanceVariableNames: 'transactionLog sessions filer repositoryController largeCollectionManagers systemReadStrategy nextOid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-private'!

!MaObjectRepository class methodsFor: 'creation' stamp: 'cmm 9/24/2004 12:50'!
create: aFileDirectory controller: aMaRepositoryController

	^ (self new repositoryController: aMaRepositoryController) create: aFileDirectory! !

!MaObjectRepository class methodsFor: 'creation' stamp: 'cmm 9/24/2004 15:39'!
open: aFileDirectory controller: aMaRepositoryController

	^self new
		repositoryController: aMaRepositoryController;
		open: aFileDirectory! !

!MaObjectRepository class methodsFor: 'accessing' stamp: ''!
recognitionSignature

	^5191969
! !

!MaObjectRepository methodsFor: 'actions' stamp: 'cmm 1/18/2005 22:39'!
abortTransactionFor: sessionId

	^ transactionLog 
		abortTransactionEntryFor: sessionId
		repository: self! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 2/8/2005 23:37'!
anchorByteArrayUsing: aMaReadStrategy

	| anchorOid |
	^ MaOidCalculator oidForNil = (anchorOid _ filer anchorOid)
		ifTrue:
			[ (self serverSerializer serializeGraph: MaRootAnchor new) trimmedByteArray ]
		ifFalse:
			[ self
				byteArrayAt: anchorOid
				using: aMaReadStrategy ]! !

!MaObjectRepository methodsFor: 'actions' stamp: 'cmm 12/2/2004 13:27'!
assignPermanentOidFor: aMaObjectBuffer mapUsing: aDictionary andAddNewObjectOidTo: aSet
	"aMaObjectBuffer is going to written very soon, however, none of its loids are permanent (they are all > newOidMinimum).  This method assigns and populates aDictionary with a map of the temporary to the permanent loids for aMaObjectBuffer (not the oids they link, however) as it populates its oid."

	| newOid |
	aMaObjectBuffer oid: (
		aDictionary
			at: aMaObjectBuffer oid
			put: (newOid _ self getNextOid)).
	aSet add: newOid! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 12/2/2004 13:27'!
assignPermanentOidsIn: aMaCommitPackage andAddNewObjectOidsTo: aSet

	| tempToPermOidsMap |

	tempToPermOidsMap _ Dictionary new: 50.
	aMaCommitPackage newObjectsDo:
		[ :eachBuffer |
		self
			assignPermanentOidFor: eachBuffer
			mapUsing: tempToPermOidsMap
			andAddNewObjectOidTo: aSet ].
	^ tempToPermOidsMap! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 12/9/2002 18:33'!
byteArrayAt: loidInteger using: aMaReadStrategy

	^(self
		graphBufferAt: loidInteger
		using: aMaReadStrategy) trimmedByteArray! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:41'!
classDefinitionsByteArray
	"When initially creating the repository, before even the system root is
	written, the classDefinitionsOid will be a new-object oid."

	| loid |

	^MaOidCalculator oidForNil = (loid _ filer classDefinitionsOid)
		ifTrue:
			[ (self serverSerializer serializeGraph: repositoryController definition classDefinitions) trimmedByteArray ]
		ifFalse:
			[ self
				byteArrayAt: loid
				using: MaBasicReadStrategy deep "we need it all" ]! !

!MaObjectRepository methodsFor: 'actions' stamp: 'cmm 12/18/2002 22:26'!
close

	filer ifNotNil: [ filer close ].
	largeCollectionManagers do: [ :each | each close ]! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 9/24/2004 13:37'!
collectionFilenameFor: oidInteger

	^ self directory fullNameFor:
		(String streamContents:
			[ : stream |
			stream
				print: oidInteger ;
				nextPut: $. ;
				nextPutAll: MaHashIndex suggestedFileExtension ])! !

!MaObjectRepository methodsFor: 'magma-collections' stamp: 'cmm 7/2/2004 16:26'!
collectionManagerFor: oidInteger

	^ largeCollectionManagers
		at: oidInteger
		ifAbsent:
			[ MagmaSoftwareError signal:
				'MagmaCollection ' , oidInteger printString ,
					' not found.  MaObjectRepository>>collectionManagerFor:' ]! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 1/18/2005 22:30'!
commitEntryFor: sessionId beginAnother: aBoolean

	^ transactionLog
		renewEntryFor: sessionId
		beginAnother: aBoolean
		for: self! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 12/2/2004 13:26'!
create: aFileDirectory

	filer _ MaObjectFiler create: aFileDirectory.
	nextOid _ filer getNextOid.
	^ self! !

!MaObjectRepository methodsFor: 'magma-collections' stamp: 'cmm 9/26/2004 19:08'!
createLcMemberIndex: loidInteger
	"Create and then close.  There is some initialization that needs to occur when opening."

	(MaHashIndex
		create: (self collectionFilenameFor: loidInteger)
		keySize: 64
		hashRecordSize: 100) close
! !

!MaObjectRepository methodsFor: 'magma-collections' stamp: 'cmm 9/23/2004 10:26'!
createNewLargeCollection: oidInteger

	self
		createLcMemberIndex: oidInteger ;
		createUserIndexes: oidInteger! !

!MaObjectRepository methodsFor: 'magma-collections' stamp: 'cmm 4/27/2004 00:01'!
createUserIndexes: oidInteger
	"Create and then close.  There is some initialization that needs to occur when opening."

	| mc |
	mc _ 
		self session 
			objectWithOid: oidInteger 
			ifAbsent:
				[ MagmaSoftwareError signal: 'expected to know about MagmaCollection ', oidInteger, ' here.' ].
	mc indexes do:
		[ : eachIndexDefinition |
		(self ensureMagmaCollectionManagerCreatedFor: mc) ensureIndex: eachIndexDefinition ]! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:43'!
definitionByteArray

	| oid |
	^MaOidCalculator oidForNil = (oid _ filer definitionOid)
		ifTrue:
			[ (self serverSerializer serializeGraph: repositoryController definition) trimmedByteArray ]
		ifFalse:
			[ self
				byteArrayAt: oid
				using: MaBasicReadStrategy deep "we need it all" ]! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 9/24/2004 15:42'!
directory

	^ filer directory! !

!MaObjectRepository methodsFor: 'building' stamp: 'cmm 10/1/2004 14:44'!
ensureMagmaCollectionManagerCreatedFor: aMagmaCollection

	| answer |
	answer _ largeCollectionManagers
		at: (self session oidFor: aMagmaCollection)
		ifAbsentPut:
			[ MaLargeCollectionManager
				collection: aMagmaCollection
				repository: self
				oidOfIndexesCollection: (self session oidFor: aMagmaCollection indexes) ].
	aMagmaCollection indexesDo: [ : each | answer ensureIndex: each ].
	^ answer! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 2/8/2005 17:59'!
establishLinksToNewObjectsIn: aMaCommitPackage using: newOidToPermanentOidMap
	"Update all new-object oids in aMaCommitPackage
	with their permanent counter-part.  newOidToPermanentOidMap has an entry for
	them all."

	aMaCommitPackage objectsDo:
		[ :eachBuffer |
		eachBuffer isPointers
			ifTrue:
				[ eachBuffer instVarsDoWithIndex:
					[ :oid :index |
					(MaOidCalculator isOidForNewObject: oid)
						ifTrue:
							[ eachBuffer
								maInstVarAt: index
								put: (newOidToPermanentOidMap at: oid) ] ] ] ]! !

!MaObjectRepository methodsFor: 'accessing' stamp: ''!
filer

	^filer
! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 12/2/2004 13:25'!
getNextOid

	^nextOid _ nextOid + 1! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 1/25/2005 14:04'!
graphBufferAt: oidInteger using: aMaReadStrategy
	"Answers a MaSerializedGraphBuffer."

	| answer rootBuffer |
	answer _ MaSerializedGraphBuffer new: 400.
	rootBuffer _ 
		filer
			appendObject: oidInteger
			into: answer.
	rootBuffer
		appendGraphUsing: aMaReadStrategy
		into: answer
		currentDepth: 1
		minDepth: aMaReadStrategy minimumDepth
		with: Set new
		filer: filer.
	^ answer! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 4/28/2003 16:28'!
initialize

	super initialize.
	transactionLog _ MaTransactionLog new.
	largeCollectionManagers _ Dictionary new.
	sessions _ Dictionary new! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 2/1/2005 22:45'!
initializeClassDefinitionsSpecialOids
	"This collection of special oids can grow.  When it does, clients need to know about it."

	repositoryController definition classDefinitions do:
		[ : each |
		(repositoryController session isPersistent: each)
			ifTrue:
				[ transactionLog
					onChangeOf: (repositoryController session oidFor: each "OrderedCollection of definitions")
					clientsShould: #refreshClassVersions ] ]! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 2/1/2005 22:47'!
initializeSpecialOidsList
	"See MagmaSession>>#handleSpecialOidNotifications:"

	| classDefinitions session |
	classDefinitions _ repositoryController definition classDefinitions.
	session _ repositoryController session.
	(session isPersistent: classDefinitions)
		ifTrue:
			[ transactionLog
				onChangeOf: (repositoryController session oidFor: repositoryController definition classDefinitions)
				clientsShould: #refreshClassDefinitions ].
	self initializeClassDefinitionsSpecialOids! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 2/9/2005 10:26'!
initializeSystemReadStrategyUsing: aMaClassIdManager

	"The object and its immediate variables"
self maMarked: 'dev'.  "Should minimumDepth be 0?  If not, then perhaps we don't need to extend any Collection 1-level further, since the point for it was to merely get its immediately referenced objects...??"
	systemReadStrategy _ MaReadStrategy minimumDepth: 1.
	systemReadStrategy makeReadyForUseUsing: aMaClassIdManager! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 11/1/2004 10:23'!
isOpen

	^ filer notNil and: [ filer isOpen ]! !

!MaObjectRepository methodsFor: 'accessing' stamp: ''!
largeCollectionManagers

	^largeCollectionManagers! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 12/2/2004 13:29'!
linkNewObjectsIn: aMaCommitPackage recordPermenantOidsUsing: aMaCommitResult
	"Some of the objects in each graphBuffers object buffers are new objects.  These need to be assigned a permanent loid and all of the objects that reference them need to have their references updated to reflect the new permanent loid."

	| newObjects tempToPermanentOidsMap |

	tempToPermanentOidsMap _
		self
			assignPermanentOidsIn: aMaCommitPackage
			andAddNewObjectOidsTo: (newObjects _ Set new: 100).
	self
		establishLinksToNewObjectsIn: aMaCommitPackage
		using: tempToPermanentOidsMap.
	aMaCommitResult permanentOids: tempToPermanentOidsMap.
	^ newObjects! !

!MaObjectRepository methodsFor: 'magma-collections' stamp: 'cmm 9/26/2004 21:06'!
magmaCollectionManagersDo: aBlock

	largeCollectionManagers do: aBlock! !

!MaObjectRepository methodsFor: 'building' stamp: 'cmm 6/7/2004 15:20'!
newSessionFor: userIdString numberOfChallengers: anInteger
	"Answer an Association whose key is the session id, value is the classMap
	array for that session."

	| connection |
	connection _
		transactionLog
			newSessionFor: userIdString
			numberOfChallengers: anInteger.
	sessions at: connection sessionId put: connection.
	^(Array new: 3)
		at: 1
			put: connection sessionId;
		at: 2
			put: self classDefinitionsByteArray ;
		at: 3
			put: self definitionByteArray;
		yourself! !

!MaObjectRepository methodsFor: 'building' stamp: 'cmm 1/28/2005 00:04'!
newTransactionFor: sessionIdInteger

	(transactionLog entryFor: sessionIdInteger) isCommitEntry
		ifTrue:
			[ MagmaSoftwareError signal: 'Already in a transaction.' ].
	^ transactionLog
		newTransactionFor: sessionIdInteger
		repository: self! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:26'!
objectCount

	^nextOid - MaOidCalculator firstUserObjectOid! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 4/21/2003 16:29'!
objectFileSize

	^filer objectFileSize! !

!MaObjectRepository methodsFor: 'actions' stamp: 'cmm 12/2/2004 13:26'!
open: aFileDirectory

	filer _ MaObjectFiler open: aFileDirectory.
	nextOid _ filer getNextOid! !

!MaObjectRepository methodsFor: 'building' stamp: 'cmm 4/30/2004 00:21'!
openLargeCollectionIfNecessary: aMagmaCollection

	(self ensureMagmaCollectionManagerCreatedFor: aMagmaCollection) ensureOpen! !

!MaObjectRepository methodsFor: 'actions' stamp: 'cmm 7/2/2004 15:56'!
removeSessionFor: sessionId

	sessions
		removeKey: sessionId
		ifAbsent: [ MagmaUserError signal: 'session not connected.' ].
	transactionLog
		removeEntryForSessionId: sessionId
		ifAbsent: [ MagmaUserError signal: 'session not connected.' ]! !

!MaObjectRepository methodsFor: 'actions' stamp: 'cmm 4/28/2003 23:51'!
renewCurrentReadStrategy: aMaReadStrategy for: sessionId

	| session |
	session _ self sessionWithId: sessionId.
	aMaReadStrategy ifNotNil: [ session currentReadStrategy: aMaReadStrategy ].
	^session currentReadStrategy! !

!MaObjectRepository methodsFor: 'actions' stamp: 'cmm 12/16/2002 23:52'!
renewRefreshFlagFor: sessionId

	^(transactionLog entryFor: sessionId) renewRefreshFlag! !

!MaObjectRepository methodsFor: 'actions' stamp: 'cmm 1/25/2005 17:03'!
renewServerNotificationsIn: aMagmaServerResult for: sessionId

	self
		renewServerNotificationsIn: aMagmaServerResult
		for: sessionId
		from: (transactionLog entryFor: sessionId)! !

!MaObjectRepository methodsFor: 'actions' stamp: 'cmm 1/25/2005 17:02'!
renewServerNotificationsIn: aMagmaServerResult for: sessionId from: aMaTransactionLogEntry

	aMagmaServerResult
		serverNotifications: aMaTransactionLogEntry renewServerNotifications ;
		shouldRefresh: (self renewRefreshFlagFor: sessionId).
	aMagmaServerResult serverNotifications keysAndValuesDo:
		[ : eachKey : eachSet |
		aMagmaServerResult serverNotifications
			at: eachKey
			put: (eachSet collect: [ : eachOid | self byteArrayAt: eachOid using: MaReadStrategy deep ]) ]! !

!MaObjectRepository methodsFor: 'building' stamp: ''!
repositoryController: aMaRepositoryController

	repositoryController _ aMaRepositoryController.
	aMaRepositoryController repository == self ifFalse: [ aMaRepositoryController repository: self ]
! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 12/31/2002 12:56'!
serverSerializer

	^repositoryController serverSerializer! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 12/31/2002 12:55'!
session

	^repositoryController session! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 4/28/2003 23:51'!
sessionWithId: anInteger

	^sessions 
		at: anInteger
		ifAbsent: [ MagmaUserError signal: 'session no longer valid.' ]! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 5/2/2003 15:05'!
sessions

	^sessions! !

!MaObjectRepository methodsFor: 'actions' stamp: 'cmm 12/2/2004 13:30'!
submitAll: aMaCommitPackage for: sessionId beginAnother: aBoolean
	"Save all of the serialized objects in aMaCommitPackage to the repository.
	If any of the objects in aMaCommitPackage have been changed by other transactions
	signal a commit failure."

	| entry |
	entry _ self 
		commitEntryFor: sessionId 
		beginAnother: aBoolean.
	entry isCommitEntry ifFalse: [ MagmaUserError signal: 'No transaction to commit.' ].
	entry
		determineResultFor: aMaCommitPackage
		using: largeCollectionManagers.
	entry result hasConflicts
		ifTrue:
			[ MagmaCommitError new
				result: entry result;
				signal ]
		ifFalse:
			[ self
				writeAll: aMaCommitPackage
				recordPermenantOidsInResultFor: entry ].
	"Make sure system session doesn't exceed maximumNumberOfChallengers"
	self maMarked: 'performance'.  "the repositoryController session never enters a transaction, so it should be sensitive to the maximumNumberOfChallengers built-in mechanism for suggesting an abort.  Let's test that.."
	(sessionId ~= repositoryController sessionId
		and: [ transactionLog isFirstEntryFor: repositoryController sessionId ])
			ifTrue: [ repositoryController refreshView ].
	^entry result! !

!MaObjectRepository methodsFor: 'read strategies' stamp: 'cmm 9/1/2003 19:11'!
systemReadStrategy

	^systemReadStrategy! !

!MaObjectRepository methodsFor: 'magma-collections' stamp: 'cmm 12/2/2004 13:18'!
updateLargeCollectionsIn: aMaCommitPackage recordResultsIn: aMaCommitResult
	"The repositoryControllers sessions view of the repository must be
	completely refreshed, it must know about all new collections."
	aMaCommitPackage allLargeCollectionChangesDo:
		[ :each |
		each isNewCollection
			ifTrue:
				[ | permanentOid |
				permanentOid _ aMaCommitResult permanentOids at: each collectionOid.
				self createNewLargeCollection: permanentOid.
				each collectionOid: permanentOid ] ].
	repositoryController openLargeCollections.
	aMaCommitPackage allLargeCollectionChangesDo:
		[ :each |
		(self collectionManagerFor: each collectionOid)
			process: each
			recordResultsIn: aMaCommitResult ]
! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 4/21/2003 16:02'!
version

	^filer version! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 12/2/2004 13:30'!
writeAll: aMaCommitPackage recordPermenantOidsInResultFor: aMaCommitLogEntry

	| newObjectOids |
	newObjectOids _
		self
			writeObjectsIn: aMaCommitPackage
			recordPermenantOidsIn: aMaCommitLogEntry result.
	aMaCommitLogEntry
		recordSuccessfullyCommittedIn: aMaCommitPackage
		using: newObjectOids.
	aMaCommitLogEntry hasAnyCommitted
		ifTrue:
			[ transactionLog challengeEntriesWith: aMaCommitLogEntry ].
	(aMaCommitPackage shouldServerRefresh or: [ aMaCommitLogEntry shouldServerRefresh ])
		ifTrue:
			[ repositoryController refreshView ].
	aMaCommitLogEntry didCommitSpecialOid
		ifTrue:
			[ self initializeClassDefinitionsSpecialOids ].
	self
		updateLargeCollectionsIn: aMaCommitPackage
		recordResultsIn: aMaCommitLogEntry result! !

!MaObjectRepository methodsFor: 'private' stamp: 'cmm 12/2/2004 13:29'!
writeObjectsIn: aMaCommitPackage recordPermenantOidsIn: aMaCommitResult

	| newObjectsOids |
	newObjectsOids _
		self
			linkNewObjectsIn: aMaCommitPackage
			recordPermenantOidsUsing: aMaCommitResult.
	aMaCommitPackage objectsDo:
		[ :eachBuffer |
		filer
			write: eachBuffer
			index: (newObjectsOids includes: eachBuffer oid) ].
	^ newObjectsOids! !

MaObject subclass: #MaTransactionLog
	instanceVariableNames: 'entries specialOids'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-private'!

!MaTransactionLog commentStamp: '<historical>' prior: 0!
This class resides on the server.
!

!MaTransactionLog methodsFor: 'actions' stamp: 'cmm 1/18/2005 22:43'!
abortTransactionEntryFor: sessionIdInteger repository: aMaObjectRepository

	^(self
		renewEntryFor: sessionIdInteger
		beginAnother: false
		for: aMaObjectRepository) result! !

!MaTransactionLog methodsFor: 'private' stamp: 'cmm 5/20/2004 01:04'!
challengeEntriesWith: aMaCommitLogEntry
	"We record all objects that were committed to all the entries in the receiver.  Some of the entries are in transaction, some are not.  The ones that are will use aMaCommitLogEntry to verify their commit has no conflicts with this entry.  The ones that are not will use the result of the receiver to know which objects need refreshed."

	| entriesToRemove |
	entriesToRemove _ nil.
	entries do:
		[ :each |
		(each isForSameSessionAs: aMaCommitLogEntry)
			ifFalse:
				[ each addChallengingEntry: aMaCommitLogEntry.
				each
					recordChangesToSpecialObjectsIn: aMaCommitLogEntry
					using: self.
				each hasExcessiveNumberOfChallengers
					ifTrue:
						[ self maMarked: 'dev'.
						"here is where we manage the health of the server.  Our current strategy is that your session 'times out' if you stay idle and get too far out of sync w/ the db.  Further work can be done here.  We should look into just marking this LogEntry 'bad' then, later, when they finally refresh, force it to refresh this sessions entire readSet..  something like that.."
						entriesToRemove ifNil: [ entriesToRemove _ OrderedCollection new ].
						entriesToRemove add: each.
						each needsToRefresh: true ] ] ].
	entriesToRemove ifNotNil:
		[ entriesToRemove 
			do:
				[ :each |
				self
					removeEntryForSessionId: each sessionId
					ifAbsent: [ "shouldn't happen" ] ] ]! !

!MaTransactionLog methodsFor: 'accessing' stamp: 'cmm 2/5/2003 20:46'!
entryFor: sessionId

	^entries
		detect: [ :each | each sessionId = sessionId ]
		ifNone: [ self signalLostSession: sessionId ]! !

!MaTransactionLog methodsFor: 'private' stamp: 'cmm 6/2/2004 12:25'!
initialize

	super initialize.
	"An OrderedCollection of MaCommitLogEntrys and MaTransactionLogEntrys.."
	entries _ OrderedCollection new.
	specialOids _ Dictionary new! !

!MaTransactionLog methodsFor: 'testing' stamp: 'cmm 12/31/2002 12:31'!
isFirstEntryFor: sessionId

	^entries notEmpty and: [ entries first connection sessionId = sessionId ]
! !

!MaTransactionLog methodsFor: 'building' stamp: 'cmm 4/28/2003 16:21'!
newSessionFor: userIdString numberOfChallengers: anInteger

	^(entries add: (
		MaTransactionLogEntry
			connection: (
				MagmaClientConnection
					userId: userIdString
					sessionId: self nextAvailableSessionId
					maximumNumberOfChallengers: anInteger)
			log: self)) connection! !

!MaTransactionLog methodsFor: 'building' stamp: 'cmm 1/28/2005 00:04'!
newTransactionFor: sessionIdInteger repository: aMaObjectRepository

	^ (self
		renewEntryFor: sessionIdInteger
		beginAnother: true
		for: aMaObjectRepository) result! !

!MaTransactionLog methodsFor: 'creation' stamp: ''!
nextAvailableSessionId

	^(entries
		inject: 0
		into: [ :highest :each | highest max: each sessionId ]) + 1
! !

!MaTransactionLog methodsFor: 'special oids' stamp: 'cmm 5/19/2004 22:24'!
onChangeOf: anInteger clientsShould: aSymbol

	specialOids
		at: anInteger
		put: aSymbol! !

!MaTransactionLog methodsFor: 'building' stamp: 'cmm 12/31/2002 12:44'!
removeEntryForSessionId: sessionId ifAbsent: aBlock

	^entries
		maDetect: [ :each | each sessionId = sessionId ]
		ifFound: [ :foundSession | entries remove: foundSession ]
		ifNone: aBlock! !

!MaTransactionLog methodsFor: 'actions' stamp: 'cmm 1/25/2005 17:04'!
renewEntryFor: sessionIdInteger beginAnother: aBoolean for: aMaObjectRepository
	"Gives the session identified by sessionIdInteger a new TranslactionLogEntry, where its challengers will be accumulated.  The entry prior to replacement is answered."

	| entry |
	entry _ self
		renewEntryFor: sessionIdInteger
		withNew: (aBoolean ifTrue: [ MaCommitLogEntry ] ifFalse: [ MaTransactionLogEntry ])
		ifAbsent: [ self signalLostSession: sessionIdInteger ].
	aMaObjectRepository
		renewServerNotificationsIn: entry result
		for: sessionIdInteger
		from: entry.
	^ entry! !

!MaTransactionLog methodsFor: 'private' stamp: 'cmm 4/21/2003 14:50'!
renewEntryFor: sessionIdInteger withNew: aClass ifAbsent: aBlock
	"aClass should be either MaTransactionLogEntry or MaCommitLogEntry"

	| entry |

	entry _
		(self
			removeEntryForSessionId: sessionIdInteger
			ifAbsent: [ ^aBlock value ]).
	entry recordAllChangedObjects.
	entries add: 
		(aClass
			connection: entry result connection
			log: self).
	^entry! !

!MaTransactionLog methodsFor: 'private' stamp: 'cmm 12/20/2002 12:43'!
signalLostSession: anInteger

	MagmaUserError signal:
		'Session ', anInteger printString, ' has timed out.  Did you stay idle for a long time?  Please reconnect.'! !

!MaTransactionLog methodsFor: 'special oids' stamp: 'cmm 5/19/2004 00:10'!
specialOidsDo: twoArgBlock

	specialOids keysAndValuesDo: twoArgBlock! !

MaObject subclass: #MaTransactionLogEntry
	instanceVariableNames: 'log result challengingEntries needsNewClassDefinitions needsToRefresh serverNotifications'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-private'!

MaTransactionLogEntry subclass: #MaCommitLogEntry
	instanceVariableNames: 'committed didCommitSpecialOid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-private'!

!MaCommitLogEntry methodsFor: 'private accessing' stamp: ''!
committed

	^committed! !

!MaCommitLogEntry methodsFor: 'building' stamp: 'cmm 10/15/2004 16:57'!
determineResultFor: aMaCommitPackage using: lcManagersDictionary

	self
		recordLargeCollectionConflictsWith: aMaCommitPackage
			using: lcManagersDictionary;
		recordObjectConflictsIn: aMaCommitPackage.
	^ result! !

!MaCommitLogEntry methodsFor: 'testing' stamp: 'cmm 5/20/2004 21:39'!
didCommitSpecialOid

	^ didCommitSpecialOid! !

!MaCommitLogEntry methodsFor: 'private building' stamp: 'cmm 10/15/2004 16:57'!
failResultWith: aMagmaClientConnection on: oidInteger

	result _
		result asFailedResult
			recordObjectConflictWith: aMagmaClientConnection
			on: oidInteger! !

!MaCommitLogEntry methodsFor: 'testing' stamp: 'cmm 11/14/2002 23:39'!
hasAnyCommitted

	^committed notEmpty! !

!MaCommitLogEntry methodsFor: 'testing' stamp: 'cmm 10/15/2004 16:52'!
hasCommitted: oidInteger

	^ committed includesKey: oidInteger
! !

!MaCommitLogEntry methodsFor: 'private initializing' stamp: 'cmm 5/20/2004 21:36'!
initialize

	super initialize.
	committed _ Dictionary new.
	didCommitSpecialOid _ false! !

!MaCommitLogEntry methodsFor: 'private initializing' stamp: ''!
initializeResult

	result _ MaCommitResult new
! !

!MaCommitLogEntry methodsFor: 'testing' stamp: ''!
isCommitEntry

	^true
! !

!MaCommitLogEntry methodsFor: 'building' stamp: 'cmm 5/20/2004 21:38'!
noteDidCommitSpecialOid

	didCommitSpecialOid _ true! !

!MaCommitLogEntry methodsFor: 'private actions' stamp: 'cmm 12/2/2004 13:20'!
recordLargeCollectionConflictsWith: aMaCommitPackage using: lcManagersDictionary

	aMaCommitPackage allLargeCollectionChangesDo:
		[ :eachChanges |
		eachChanges isNewCollection ifFalse:
			[ | collectionManager |
			collectionManager _ lcManagersDictionary at: eachChanges collectionOid.
			"Fail my result if the collection is locked."
			(collectionManager isLocked
				and: [ self connection ~= collectionManager lockedBy ])
					ifTrue:
						[ self
							failResultWith: collectionManager lockedBy
							on: eachChanges collectionOid ].

			challengingEntries do:
				[ :eachEntry |
				"Fail my result if any indexes have been added or removed since my last transaction boundary (a loooong transaction!!)."
				(eachEntry hasCommitted: collectionManager oidOfIndexesCollection)
					ifTrue:
						[ self
							failResultWith: eachEntry connection
							on: collectionManager oidOfIndexesCollection ].
				"Fail my result if any objects being added or removed have been changed by any other session."
				eachChanges additionsDo:
					[ :eachOid :eachHashIndexValues |
					(eachEntry hasCommitted: eachOid)
						ifTrue:
							[ self
								failResultWith: eachEntry connection
								on: eachOid ] ].
				eachChanges removedDo:
					[ :eachOid :eachHashIndexValues |
					(eachEntry hasCommitted: eachOid)
						ifTrue:
							[ self
								failResultWith: eachEntry connection
								on: eachOid ] ] ] ] ]! !

!MaCommitLogEntry methodsFor: 'private building' stamp: 'cmm 10/15/2004 16:56'!
recordObjectConflictsIn: aMaCommitPackage
	"Go through everyone who has challenged me.  Determine if they have a same changed
	oid that I have.  Also fail if a new instance of a class is being added and shouldn't be."

	aMaCommitPackage persistentObjectsDo:
		[ :eachObjectBuffer |
		challengingEntries do:
			[ :eachEntry |
			(eachEntry hasCommitted: eachObjectBuffer oid)
				ifTrue:
					[ self
						failResultWith: eachEntry connection
						on: eachObjectBuffer oid ] ] ]! !

!MaCommitLogEntry methodsFor: 'private building' stamp: 'cmm 10/8/2004 16:47'!
recordSuccessfulObjectCommit: aMaObjectBuffer

	committed
		at: aMaObjectBuffer oid
		put: aMaObjectBuffer! !

!MaCommitLogEntry methodsFor: 'building' stamp: 'cmm 10/10/2004 23:04'!
recordSuccessfullyCommittedIn: aMaCommitPackage using: newObjectOids
	"It is too late to utilize aMaCommitPackage>>newObjectsDo: because it has
	already been assigned its permanent loids and written out.  Now we must utilize
	the newObjectLoids Set to determine which buffers are for new objects."

	aMaCommitPackage objectsDo:
		[ : eachBuffer |
		(newObjectOids includes: eachBuffer oid)
			ifTrue:
				[ result recordNewObjectBuffer: eachBuffer copyWithSameBuffer ]
			ifFalse:
				[ self recordSuccessfulObjectCommit: eachBuffer copyWithSameBuffer ] ].
	result changedObjectBuffers: committed! !

!MaCommitLogEntry methodsFor: 'testing' stamp: 'cmm 6/18/2004 15:52'!
shouldServerRefresh

	^ self didCommitSpecialOid! !

!MaCommitLogEntry methodsFor: 'accessing' stamp: 'cmm 10/15/2004 16:57'!
stopTime

	^ result stopTime
! !

!MaTransactionLogEntry class methodsFor: 'creation' stamp: 'cmm 12/17/2002 15:22'!
connection: aMagmaClientConnection log: aMaTransactionLog

	^self new 
		connection: aMagmaClientConnection;
		log: aMaTransactionLog;
		yourself! !

!MaTransactionLogEntry methodsFor: 'building' stamp: 'cmm 10/15/2004 16:56'!
addChallengingEntry: aMaCommitLogEntry

	challengingEntries add: aMaCommitLogEntry! !

!MaTransactionLogEntry methodsFor: 'accessing' stamp: 'cmm 10/15/2004 16:58'!
connection

	^ result connection
! !

!MaTransactionLogEntry methodsFor: 'private' stamp: 'cmm 10/15/2004 16:58'!
connection: aMagmaClientConnection

	result connection: aMagmaClientConnection
! !

!MaTransactionLogEntry methodsFor: 'testing' stamp: 'cmm 10/15/2004 16:56'!
hasExcessiveNumberOfChallengers

	^ challengingEntries size > self connection maximumNumberOfChallengers
! !

!MaTransactionLogEntry methodsFor: 'private' stamp: 'cmm 6/7/2004 15:40'!
initialize
	"of MaTransactionLogEntries or MaCommitLogEntries that challenge me."

	super initialize.
	challengingEntries _ OrderedCollection new.
	self initializeResult.
	needsNewClassDefinitions _ false.
	needsToRefresh _ false.
	self initializeServerNotifications! !

!MaTransactionLogEntry methodsFor: 'private' stamp: ''!
initializeResult

	result _ MaRefreshViewResult new
! !

!MaTransactionLogEntry methodsFor: 'actions' stamp: 'cmm 5/19/2004 00:20'!
initializeServerNotifications

	serverNotifications _ Dictionary new! !

!MaTransactionLogEntry methodsFor: 'testing' stamp: ''!
isCommitEntry

	^false
! !

!MaTransactionLogEntry methodsFor: 'testing' stamp: 'cmm 3/3/2002 19:00'!
isForSameSessionAs: aMaTransactionLogEntry

	^self connection == aMaTransactionLogEntry connection
! !

!MaTransactionLogEntry methodsFor: 'private' stamp: 'cmm 12/17/2002 15:22'!
log: aMaTransactionLog

	log _ aMaTransactionLog! !

!MaTransactionLogEntry methodsFor: 'printing' stamp: 'cmm 6/20/2004 12:06'!
maPrintAbbreviatedOn: aStream

	aStream
		maPrint: '(' ;
		maPrint: self sessionId ;
		maPrint: ') ' ;
		maPrint: result userId! !

!MaTransactionLogEntry methodsFor: 'accessing' stamp: 'cmm 5/17/2004 23:49'!
needsNewClassDefinitions: aBoolean

	needsNewClassDefinitions _ aBoolean! !

!MaTransactionLogEntry methodsFor: 'accessing' stamp: 'cmm 12/16/2002 23:28'!
needsToRefresh: aBoolean

	needsToRefresh _ aBoolean! !

!MaTransactionLogEntry methodsFor: 'accessing' stamp: 'cmm 10/15/2004 16:56'!
recordAllChangedObjects
	"Record all of the objects that the client will need to refresh."

	challengingEntries do: [ :each | result addToBeRefreshed: each committed ]
! !

!MaTransactionLogEntry methodsFor: 'actions' stamp: 'cmm 6/9/2004 16:58'!
recordChangesToSpecialObjectsIn: aMaCommitLogEntry using: aMaTransactionLog

	aMaTransactionLog specialOidsDo:
		[ : eachOid : eachKey |
		(aMaCommitLogEntry hasCommitted: eachOid)
			ifTrue:
				[ aMaCommitLogEntry noteDidCommitSpecialOid.
				(serverNotifications
					at: eachKey
					ifAbsentPut: [ Set new ]) add: eachOid ] ]! !

!MaTransactionLogEntry methodsFor: 'actions' stamp: 'cmm 5/17/2004 23:49'!
renewNewClassDefinitionFlag

	| answer |
	answer _ needsNewClassDefinitions.
	self needsNewClassDefinitions: false.
	^answer! !

!MaTransactionLogEntry methodsFor: 'actions' stamp: 'cmm 12/25/2002 12:48'!
renewRefreshFlag

	| answer |
	answer _ needsToRefresh & self isCommitEntry not.
	self needsToRefresh: false.
	^answer! !

!MaTransactionLogEntry methodsFor: 'actions' stamp: 'cmm 5/19/2004 22:43'!
renewServerNotifications

	| answer |
	answer _ serverNotifications.
	serverNotifications notEmpty ifTrue: [ self initializeServerNotifications ].
	^ answer! !

!MaTransactionLogEntry methodsFor: 'private' stamp: ''!
result

	^result! !

!MaTransactionLogEntry methodsFor: 'accessing' stamp: 'cmm 10/15/2004 16:58'!
sessionId

	^ result sessionId
! !

!MaTransactionLogEntry methodsFor: 'accessing' stamp: 'cmm 10/15/2004 16:58'!
startTime

	^ result startTime
! !

MaObject subclass: #MagmaCompressionResult
	instanceVariableNames: 'unreferencedClasses unreferencedMagmaCollections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-Utilities'!

!MagmaCompressionResult methodsFor: 'as yet unclassified' stamp: 'cmm 8/21/2002 21:44'!
unreferencedClasses

	^unreferencedClasses! !

!MagmaCompressionResult methodsFor: 'as yet unclassified' stamp: 'cmm 8/21/2002 21:45'!
unreferencedClasses: aCollection

	unreferencedClasses _ aCollection! !

!MagmaCompressionResult methodsFor: 'as yet unclassified' stamp: 'cmm 8/21/2002 21:45'!
unreferencedMagmaCollections

	^unreferencedMagmaCollections! !

!MagmaCompressionResult methodsFor: 'as yet unclassified' stamp: 'cmm 8/21/2002 21:45'!
unreferencedMagmaCollections: aCollection

	unreferencedMagmaCollections _ aCollection! !

MaObject subclass: #MagmaCompressor
	instanceVariableNames: 'inputController outputController referencedCollections referencedClasses classIdMap result sourceDirectory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-Utilities'!

!MagmaCompressor commentStamp: 'cmm 8/29/2002 22:35' prior: 0!
I garbage collect a Magma repository and output a smaller file by eliminating buffers no longer referenced from the root buffer.

I always create a new object file, but if you use compressAndRename, I'll rename the source files to 'old...' so you can get with using the compressed repository right away.

If you don't want me to rename, just use #compressTo:.

Oh, and I'm not meant to work while the files are on-line.  For that, use:

	yourRepositoryController garbageCollect

(Note:  a potential strategy for on-line GC would be to set a boolean flag indicating to the filer not to reuse buffers made available through grown objects, but rather to always add to the end.  During this time, a background thread can start reading from the root and build a new copy of the 'memory' map (the MaIntervalCollection).  Once it has accounted for every byte in the real memory map, we know the real one can be replaced with this new one.  Do a quick write of the new memory map and you're done!!)!

!MagmaCompressor class methodsFor: 'creation' stamp: 'cmm 9/24/2004 16:49'!
inputController: aMagmaRepositoryController
	"NOT YET SUPPORTED.  The premise of this is that you can compress a running repository, but it is not complete.  Do not use!!"
	^self new inputController: aMagmaRepositoryController! !

!MagmaCompressor class methodsFor: 'creation' stamp: 'cmm 9/24/2004 16:49'!
source: pathString

	^self new sourceDirectory: (FileDirectory on: pathString)! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 2/28/2005 15:38'!
buildClassIdMap
	"This should normally not be necessary.  But if Magma has been modified where an object is added to the repository definition, it's possible the initial class ids will not match.  This method builds a map of oldId->newId used when we write the new buffers."

	| inputClassMap outputClassMap |
	classIdMap _ Dictionary new.
	inputController requestCritical:
		[ inputClassMap _ inputController definition classDefinitions copy.
	outputClassMap _ outputController definition classDefinitions copy.
	inputClassMap keysAndValuesDo:
		[ : eachId : eachVersions |  | className |
		className _ (inputClassMap at: eachId) last className.
		"if output has consumed id for different class"
		((outputClassMap includesKey: eachId)
		and: [ (outputClassMap at: eachId) first className ~= eachVersions first className ])
			ifTrue:
				[ "try to find corresponding class-id in output, otherwise assign a new one."
				classIdMap
					at: eachId
					put:
						(outputClassMap
							maDetect: [ : eachDefinitions | eachDefinitions last className = className ]
							ifFound: [ : foundDefinitions | foundDefinitions last id ]
							ifNone: [ self nextAvailableClassId ]) ] ] ].
	classIdMap keysAndValuesDo:
		[ :eachOld :eachNew |
		MagmaNotification signal:
			'converting classId ', eachOld printString, 
			' to ', eachNew printString ]! !

!MagmaCompressor methodsFor: 'compress' stamp: 'cmm 2/28/2005 12:18'!
compressTo: outputDirectory

	| shouldCloseInput |
	shouldCloseInput _ inputController isNil.
	inputController ifNil: [ self openInput ].
	self
		createOutput: outputDirectory;
		openOutput: outputDirectory;
		ensureNoOidReuse ;
		buildClassIdMap;
		copyPrimitiveAttributes;
		writeGraphs ;
		copyMagmaCollections.
	outputController close.
	self removeUnreferencedCollectionsAndClasses: outputDirectory.
	shouldCloseInput ifTrue: [ inputController close ].
	^result
		unreferencedClasses: self unreferencedClasses;
		unreferencedMagmaCollections: self unreferencedMagmaCollections;
		yourself! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 2/28/2005 16:30'!
copyMagmaCollections

	inputController repository magmaCollectionManagersDo:
		[ : each |
		(referencedCollections includes: each collectionOid)
			ifTrue:
				[ each filenames do:
					[ : eachMcFilename |
					inputController directory
						maCopyFileNamed: eachMcFilename
						toDirectory: outputController directory ] ] ]! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 1/12/2005 21:13'!
copyPrimitiveAttributes

	| inputFiler outputFiler |
	inputFiler _ inputController repository filer.
	outputFiler _ outputController repository filer.
	inputController requestCritical:
		[ outputFiler
			signature: inputFiler signature ;
			"Even if this is a new version of Magma, the source buffers are still the old version."
			version: inputFiler version ;
			definitionOid: inputFiler definitionOid ;
			classDefinitionsOid: inputFiler classDefinitionsOid ;
			anchorOid: inputFiler anchorOid ]! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 9/24/2004 12:24'!
createOutput: aString

	MagmaRepositoryController create: aString! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 2/17/2005 13:48'!
ensureNoOidReuse
	"We can never allow an oid to be reused.  Once an object is created and persisted, its oid must be forever consumed.  Even if that object is later dereferenced, its oid will never be reused.  This is necessary to properly support MagmaForwardingProxys."

	| highestOid |
	"determine the next oid to be used in our inputController."
	highestOid _ (inputController repository filer getNextOid) - 1.
	"Force our output controller to allocate up to the current oid."
	outputController repository filer
		index: highestOid
		at: 0! !

!MagmaCompressor methodsFor: 'initialize-release' stamp: 'cmm 12/24/2002 15:51'!
initialize
	super initialize.
	referencedClasses := Set new.
	referencedCollections := Set new.
	result := MagmaCompressionResult new! !

!MagmaCompressor methodsFor: 'initialize-release' stamp: 'cmm 8/17/2002 15:25'!
inputController: aMagmaRepositoryController

	inputController _ aMagmaRepositoryController! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 2/28/2005 14:55'!
markClassReferenced: aMaObjectBuffer

	| classIdManager |
	classIdManager _ inputController session serializer classIdManager.
	(classIdManager
		definitionForClassId: aMaObjectBuffer classId
		version: aMaObjectBuffer classVersion)
		
		withAllSuperclassDefinitionsDo:
			[ : eachClassDefinition | 
			referencedClasses add: (self newClassIdFor: eachClassDefinition id) ].

	"Bring forward references to classes themselves."
	aMaObjectBuffer class = MaClassReferenceBuffer
		ifTrue:
			[ (classIdManager
				definitionForClassId: aMaObjectBuffer representedClassId 
				version: 1)
				
				withAllSuperclassDefinitionsDo:
					[ : eachClassDefinition | 
					referencedClasses add: (self newClassIdFor: eachClassDefinition id) ] ]! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 8/22/2002 21:09'!
markCollectionReferenced: oidInteger

	referencedCollections add: oidInteger! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 7/2/2004 00:07'!
newClassIdFor: sourceClassId

	^ classIdMap at: sourceClassId ifAbsent: [ sourceClassId ]! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 7/1/2004 17:22'!
nextAvailableClassId
	"Answer the lowest commonly-available classId between the input and outputController."

	^ inputController requestCritical:
		[ | inputClassMap outputClassMap |
		inputClassMap _ inputController definition classDefinitions.
		outputClassMap _ outputController definition classDefinitions.
		(inputClassMap keys max max: outputClassMap keys max) + 1 ]! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 9/24/2004 16:54'!
openInput

	inputController _ MagmaRepositoryController open: sourceDirectory pathName! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 8/14/2002 23:41'!
openOutput: aString

	outputController _ MagmaRepositoryController open: aString! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 2/23/2005 15:04'!
removeUnreferencedCollectionsAndClasses: outputDirectory

	| controller |
	controller _ outputController privateOpen: (FileDirectory on: outputDirectory).
	controller session commit:
		[ controller definition classDefinitions copy
			keysDo: 
				[ :eachId |
				(referencedClasses includes: eachId) ifFalse:
					[ controller definition removeClassWithId: eachId ] ].
		controller definition allLargeCollections copy do:
			[ :eachCollection |
			(referencedCollections includes: (controller session oidFor: eachCollection)) ifFalse:
				[ controller definition removeCollection: eachCollection ] ] ].
	controller close! !

!MagmaCompressor methodsFor: 'initialize-release' stamp: 'cmm 9/24/2004 16:50'!
sourceDirectory: aFileDirectory

	sourceDirectory _ aFileDirectory! !

!MagmaCompressor methodsFor: 'accessing' stamp: 'cmm 7/1/2004 23:35'!
unreferencedClasses

	^ outputController definition classDefinitions reject:
		[ : eachDefinitions |
		referencedClasses includes: eachDefinitions first id ]! !

!MagmaCompressor methodsFor: 'accessing' stamp: 'cmm 8/22/2002 23:58'!
unreferencedMagmaCollections

	| unreferencedOids |
	unreferencedOids _ inputController definition allLargeCollections reject: [ :each | referencedCollections includes: (inputController session oidFor: each) ].
	^unreferencedOids collect: [ :each | inputController repository collectionFilenameFor: each ]! !

!MagmaCompressor methodsFor: 'private' stamp: 'cmm 2/28/2005 16:01'!
writeGraphs

	| inputTraverser |
	inputTraverser _ MagmaFileTraverser repositoryController: inputController.
	inputTraverser anchorGraphDo:
		[ :eachBuffer |
		self markClassReferenced: eachBuffer.
		inputTraverser inDefinition ifFalse:
			[ (inputTraverser isOidForMagmaCollection: eachBuffer oid)
				ifTrue:
					[ self markCollectionReferenced: eachBuffer oid ] ].
		eachBuffer classId: (self newClassIdFor: eachBuffer classId).
		outputController requestCritical:
			[ outputController repository filer
				write: eachBuffer
				index: true ] ]! !

MaObject subclass: #MagmaFileTraverser
	instanceVariableNames: 'repositoryController oidsVisited graphBuffer directory inDefinition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-Utilities'!

!MagmaFileTraverser commentStamp: 'cmm 8/5/2002 21:45' prior: 0!
I walk the object buffers of an open Magma file and execute a Block for each buffer.

I'm useful for the Magma garbage collection function, the compression function and for general purpose information gathering about what's in the repository.!

!MagmaFileTraverser class methodsFor: 'creation' stamp: 'cmm 9/24/2004 15:56'!
for: pathString

	^ self new 
		directory: (FileDirectory on: pathString) ;
		yourself! !

!MagmaFileTraverser class methodsFor: 'creation' stamp: 'cmm 8/15/2002 22:52'!
repositoryController: aMagmaRepositoryController

	^self new repositoryController: aMagmaRepositoryController! !

!MagmaFileTraverser methodsFor: 'actions' stamp: 'cmm 1/19/2005 21:50'!
anchorGraphDo: aBlock

	self
		graphDo: aBlock
		from: (repositoryController requestCritical: [ self repository filer anchorOid ])! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 8/21/2002 00:24'!
close

	repositoryController ifNotNil:
		[ repositoryController requestCritical: [ repositoryController close ] ]! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 9/24/2004 16:15'!
deleteOidsVisited

	oidsVisited ifNotNil: [ oidsVisited close ].
	directory deleteFileNamed: self tempOidsVisitedFilename! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 2/9/2005 10:17'!
do: oneArgBlock fromBuffer: aMaObjectBuffer using: aMaReadStrategy
	"aMaObjectBuffer isPointers must be true to get here."

	aMaObjectBuffer instVarsDoWithIndex:
		[ :eachOid :index |
		self
			graphFrom: eachOid
			do: oneArgBlock
			using: aMaReadStrategy ]! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 8/14/2002 00:32'!
do: oneArgBlock fromMagmaCollection: aMaHashIndex using: aMaReadStrategy

	aMaHashIndex
		entriesFromIndex: 1
		do:
			[ :eachRecord :recordPosition :levels |
			self
				graphFrom: (eachRecord keyAtByteArrayIndex: recordPosition)
				do: oneArgBlock
				using: aMaReadStrategy ]
		until:
			[ :eachRecord :recordPosition :levels | false ]! !

!MagmaFileTraverser methodsFor: 'actions' stamp: 'cmm 1/19/2005 21:51'!
graphDo: aBlock from: oid
	"Value aBlock against every buffer in the receivers file."

	| readStrategy shouldClose |
	shouldClose _ false.
	repositoryController ifNil: [ shouldClose _ true. self open ].
	readStrategy _ MaBasicReadStrategy minimumDepth: 0.
	MagmaNotification signal: 'Beginning traversal of ', oid printString, ' of ', directory pathName.
	graphBuffer _ repositoryController session serializer graphBuffer copy resetBufferSize; yourself.  "sorry Demeter"
	[ self initializeOidsVisited.
	self
		graphFrom: oid
		do: aBlock
		using: readStrategy ]

		ensure:
			[ shouldClose ifTrue: [ self close ].
			self deleteOidsVisited ].
	MagmaNotification signal: 'Traversal of ', oid printString, ' of ', directory pathName, ' complete.'! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 2/28/2005 16:27'!
graphFrom: oidInteger do: oneArgBlock using: aMaReadStrategy

	| buffer indexPosition |
	(MaOidCalculator isOidForUserObject: oidInteger) ifFalse: [ ^self ].
	indexPosition _ MaOidCalculator indexPositionForOid: oidInteger.
	(oidsVisited at: indexPosition ifAbsent: [ 0 ]) = 0 ifFalse: [ ^self ].
	"Don't enumerate the MagmaCollections referenced from the definition, just the ones referenced from the root, that way we can properly calculate which MagmaCollections are still referenced and which are not."
	(inDefinition and: [ self isOidForMagmaCollection: oidInteger ])
		ifFalse:
			[ oidsVisited
				at: indexPosition
				put: oidInteger ].
	repositoryController requestCritical:
		[ oneArgBlock value: (buffer _ self repository filer
			appendObject: oidInteger
			into: graphBuffer) ].
	buffer isPointers ifTrue:
		[ (buffer oid = repositoryController repository filer definitionOid) 
			ifTrue: [ inDefinition _ true ].
		self
			do: oneArgBlock
			fromBuffer: buffer
			using: aMaReadStrategy.
		buffer oid = repositoryController repository filer definitionOid
			ifTrue: [ inDefinition _ false ] ].
	(inDefinition not and: [ self isOidForMagmaCollection: oidInteger ])
		ifTrue:
			[ | hashIndex |
			hashIndex _ (repositoryController requestCritical: [ repositoryController largeCollectionManagerFor: oidInteger ]) memberIndex.
			MagmaNotification signal: 'beginning enumeration of ', hashIndex size printString, ' objects in MagmaCollection ', oidInteger printString.
			self
				do: oneArgBlock
				fromMagmaCollection: hashIndex
				using: aMaReadStrategy.
			MagmaNotification signal: 'MagmaCollection enumeration complete:  ', oidInteger printString ].
	graphBuffer decreaseBufferSizeBy: buffer physicalSize! !

!MagmaFileTraverser methodsFor: 'testing' stamp: 'cmm 2/28/2005 13:40'!
inDefinition
	"Answer whether I am currently traversing inside my input-controller's repository-definition."

	^ inDefinition! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 2/28/2005 13:40'!
initialize
	super initialize.
	inDefinition _ false! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 2/16/2005 00:07'!
initializeOidsVisited

	oidsVisited ifNotNil: [ self deleteOidsVisited ].
	MaLargeCollectionOfIntegers
		create: self tempOidsVisitedFilename
		bitSize: 64.
	oidsVisited _ MaLargeCollectionOfIntegers open: self tempOidsVisitedFilename! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 8/13/2002 22:47'!
isOidForMagmaCollection: oidInteger

	^self repository largeCollectionManagers includesKey: oidInteger! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 9/24/2004 15:52'!
open
	"Use if you created with just a path, or if you know the MagmaRepositoryController needs opened.."

	repositoryController _ MagmaRepositoryController open: directory pathName! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 8/13/2002 23:29'!
repository

	^repositoryController repository! !

!MagmaFileTraverser methodsFor: 'accessing' stamp: 'cmm 1/19/2005 21:36'!
repositoryController

	^ repositoryController! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 9/24/2004 15:54'!
repositoryController: aMagmaRepositoryController

	repositoryController _ aMagmaRepositoryController.
	directory _ aMagmaRepositoryController directory! !

!MagmaFileTraverser methodsFor: 'private' stamp: 'cmm 9/26/2004 21:30'!
tempOidsVisitedFilename

	^ repositoryController directory fullNameFor: 'oidsVisited.tmp'! !

MaObject subclass: #MagmaRepositoryController
	instanceVariableNames: 'repository session serverSerializer requestInterruptGuard isReadOnly directory'
	classVariableNames: 'OpenControllers'
	poolDictionaries: ''
	category: 'Magma server-API'!

!MagmaRepositoryController class methodsFor: 'utilities' stamp: 'cmm 9/24/2004 17:00'!
compress: sourcePath to: targetPath

	(MagmaCompressor source: sourcePath) compressTo: targetPath! !

!MagmaRepositoryController class methodsFor: 'accessing' stamp: 'cmm 2/20/2005 16:29'!
controllerOpenedOn: pathName

	^ OpenControllers
		maDetect: [ : each | each directory pathName = pathName ]
		ifFound: [ : foundController | foundController ensureOpen ]
		ifNone: [ nil ]! !

!MagmaRepositoryController class methodsFor: 'utilities' stamp: 'cmm 9/26/2004 17:42'!
create: fullyQualifiedPathString
	"Creates a repository with an initial root of nil.  I #assureExistence of the fullyQualifiedPathString."

	| fd |
	self validateCanCreateIn: (fd _ FileDirectory on: fullyQualifiedPathString).
	self new createRepositoryAt: fd! !

!MagmaRepositoryController class methodsFor: 'utilities' stamp: 'cmm 1/16/2005 21:54'!
create: fullyQualifiedPathString root: anObject

	| session |
	self create: fullyQualifiedPathString.
	session _ MagmaSession openLocal: fullyQualifiedPathString.
	session
		connect: (MagmaUser id: 'system create:root:') ;
		commit: [ session root: anObject ];
		disconnect;
		closeRepository! !

!MagmaRepositoryController class methodsFor: 'utilities' stamp: 'cmm 10/1/2004 15:57'!
delete: fullyQualifiedPathString
	"Delete the just the files in fullyQualifiedPathString that are part of the Magma repository that resides there."

	| fd |
	((fd _ FileDirectory on: fullyQualifiedPathString) exists
	and: [ fd fileExists: MaObjectFiler objectsFilename ])
		ifFalse:
			[ (MagmaNotification new messageText: fullyQualifiedPathString, ' does not exist, nothing to delete.') signal.
			^ self ].
	[ (self filesFor: fullyQualifiedPathString) do:
		[ :each |
		(FileDirectory on: fullyQualifiedPathString)
			deleteFileNamed: each asString
			ifAbsent:
				[ MaNotification signal: 'Couldn''t find ', each asString ] ]
		] on: MagmaUserError do: [ :err | err resignalAs: (MagmaNotification new messageText: err messageText) ]! !

!MagmaRepositoryController class methodsFor: 'private' stamp: 'cmm 8/22/2002 20:52'!
filesFor: filename

	| controller |
	controller _ self open: filename.
	^[ controller filenames ] ensure: [ controller close ]! !

!MagmaRepositoryController class methodsFor: 'initializing' stamp: 'cmm 11/2/2004 14:38'!
initialize

	OpenControllers ifNotNil: [ OpenControllers do: [ : each | each close ] ].
	OpenControllers _ Set new.
	Smalltalk
		addToStartUpList: self;
		addToShutDownList: self! !

!MagmaRepositoryController class methodsFor: 'private' stamp: 'cmm 9/26/2004 19:21'!
open: fullyQualifiedPathString

	^ self new open: (FileDirectory on: fullyQualifiedPathString)! !

!MagmaRepositoryController class methodsFor: 'accessing' stamp: 'cmm 10/26/2004 12:48'!
openedOn: fullyQualifiedPathString

	| existingController |
	^ (existingController _ self controllerOpenedOn: fullyQualifiedPathString)
		ifNil: [ self open: fullyQualifiedPathString ]
		ifNotNil: [ existingController ]! !

!MagmaRepositoryController class methodsFor: 'private' stamp: 'cmm 2/2/2005 12:41'!
protocol
	"This is the protocol needed to talk to a magma server."
	^ { 
	"core"
		LargePositiveInteger. MaSerializedGraphBuffer. 
	"part of MagmaCollectionChanges"
		MagmaCollectionChanges.  MagmaSetChanges.  IdentityDictionary.  Association.
	"extra objects for some requests."
		MaCommitPackage.  MaBasicReadStrategy.  MaReadStrategy.
	"MagmaCollection changes objects"
		MaChangedKeySpecification.
	"various responses"
		MagmaId. UUID. MaReadResult. MaFailedCommitResult. MagmaClientConnection. MaSegmentRequestResult. MaRefreshViewResult. MaCommitResult. MaByteObjectBuffer. MaVariableObjectBuffer. MaFixedObjectBuffer.  MaClassReferenceBuffer.  MaVariableWordBuffer.  MagmaCommitConflict }, 
	"exceptions"
		MaError allSubclasses asArray,
	"various requests"
		MagmaRepositoryRequest allSubclasses asArray! !

!MagmaRepositoryController class methodsFor: 'utilities' stamp: 'cmm 9/24/2004 13:01'!
repositoryExistsIn: aFileDirectory

	^ (aFileDirectory directoryEntryFor: MaObjectFiler objectsFilename) notNil! !

!MagmaRepositoryController class methodsFor: 'initializing' stamp: 'cmm 12/27/2004 23:16'!
shutDown: aboutToQuit

	super shutDown: aboutToQuit.
	MagmaSession shutDown: aboutToQuit.
	OpenControllers
		do:
			[ :each | 
			[ MagmaNotification signal: 'closing Magma repository ', each pathName asString, '.  Will reopen on next startup.' ]
				on: MagmaNotification
				do: [ : noti | Transcript cr; show: noti messageText. noti pass ].
			each primClose ]! !

!MagmaRepositoryController class methodsFor: 'initializing' stamp: 'cmm 2/20/2005 23:01'!
startUp: amResuming

	super startUp: amResuming.
	OpenControllers copy do: 
		[ :each | 
		[ [ each ensureOpen ]
			on: MagmaNotification
			do: [ : noti | Transcript cr; show: noti messageText. noti pass ] ]
				on: MagmaUserError
				do: 
					[ : error | "not present anymore, remove from OpenControllers and resignal."
					each close.
					error pass ] ].
	"Now that we're open, ensure any server-sockets that may need to restart can be."
	MaServerSocket startUp: amResuming! !

!MagmaRepositoryController class methodsFor: 'private' stamp: 'cmm 5/1/2003 00:24'!
systemSessionUserId

	^'__system'! !

!MagmaRepositoryController class methodsFor: 'validation' stamp: 'cmm 9/24/2004 12:32'!
validateCanCreateIn: aFileDirectory
	"Magma databases do not share the same directory.  Not only would it be hard to identify which files go with which repository, some of the filenames are based on oids, which would not always be unique across repositories."

	(aFileDirectory exists and: [ self repositoryExistsIn: aFileDirectory ])
		ifTrue:
			[ MagmaUserError signal: aFileDirectory pathName, ' already has a Magma repository in it.  A directory may contain only one Magma repository.' ]
! !

!MagmaRepositoryController methodsFor: 'client requests' stamp: ''!
abortTransactionFor: sessionId

	^self repository abortTransactionFor: sessionId
! !

!MagmaRepositoryController methodsFor: 'statistics' stamp: 'cmm 4/21/2003 16:28'!
averageObjectSize

	^repository objectFileSize // self objectCount! !

!MagmaRepositoryController methodsFor: 'security' stamp: 'cmm 4/30/2003 17:21'!
beReadOnly

	self requestCritical: [ isReadOnly _ true ]! !

!MagmaRepositoryController methodsFor: 'security' stamp: 'cmm 4/30/2003 17:22'!
beReadWrite

	self requestCritical: [ isReadOnly _ false ]! !

!MagmaRepositoryController methodsFor: 'accessing' stamp: 'cmm 10/24/2004 23:14'!
close

	OpenControllers remove: self ifAbsent: [ "do nothing" ].
	self primClose! !

!MagmaRepositoryController methodsFor: 'client requests' stamp: 'cmm 10/26/2004 21:54'!
codeBaseByteArray

	^Array
		with: repository classDefinitionsByteArray
		with: (serverSerializer serializeGraph: self definition codeBase) trimmedByteArray! !

!MagmaRepositoryController methodsFor: 'initializing' stamp: 'cmm 1/16/2005 21:54'!
connect

	session connect: (MagmaUser id: self class systemSessionUserId).
	repository initializeSpecialOidsList! !

!MagmaRepositoryController methodsFor: 'unsupported' stamp: 'cmm 6/23/2002 10:48'!
connections
	"Used for monitoring server status via some console gui."

	self maMarked: 'dev'.! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 12/29/2004 00:22'!
createRepositoryAt: aFileDirectory

	| anchor |
	directory _ aFileDirectory.
	self
		repository: (
			MaObjectRepository
				create: aFileDirectory
				controller: self);
		connect;
		forceWrite:
			(anchor _ MaRootAnchor new
				definition: self definition ;
				yourself).
	repository filer
		anchorOid: (self session oidFor: anchor);
		classDefinitionsOid: (self session oidFor: self definition classDefinitions);
		definitionOid: (self session oidFor: self definition).
	self close! !

!MagmaRepositoryController methodsFor: 'accessing' stamp: 'cmm 5/2/2004 20:40'!
definition
	"Answers a MagmaRepositoryDefinition"

	^ session definition! !

!MagmaRepositoryController methodsFor: 'accessing' stamp: 'cmm 9/24/2004 15:55'!
directory
	"Answer the directory in which my files reside."
	"Note, this is the same FileDirectory that MaObjectFiler has.  It was necessary to duplicate this here to support the auto-reopen feature upon image restart."
	^ directory! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 12/26/2004 22:38'!
disconnect: sessionId

	repository removeSessionFor: sessionId.
	^nil "answer nil to minimize the serialized response."! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 2/20/2005 16:31'!
ensureOpen

	self isOpen ifFalse: [ self open ]! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 9/1/2003 19:10'!
ensureReadStrategy: aMaReadStrategy forSession: sessionId

	| strategy |
	^(strategy _
		repository
			renewCurrentReadStrategy: aMaReadStrategy
			for: sessionId)

				ifNil: [ repository systemReadStrategy ] 
				ifNotNil: [ strategy ]! !

!MagmaRepositoryController methodsFor: 'accessing' stamp: 'cmm 9/26/2004 21:04'!
filenames

	^ { MaObjectFiler objectsFilename.  MaObjectFiler objectPointersFilename },
	(repository largeCollectionManagers 
		inject: OrderedCollection new
		into:
			[ : coll : each |
			coll
				addAll: each filenames ;
				yourself ])! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 12/29/2004 00:09'!
forceWrite: anObject
	"This is somewhat of a hacking method to enable us to write objects needed
	for the repository to operate (i.e., commit transactions) during initial creation."

	| commitPackage |
	session begin.  "Begin a tran to allow the submitAll:for:.."
	commitPackage _ MaCommitPackage new.
	session serializer
		serializeGraph: anObject
		do: [ :eachObject | commitPackage addObject: eachObject ].
	commitPackage copy serializeObjectsUsing: session.
	commitPackage serializeObjectsUsing: session.
	session
		refreshViewUsing: (
			self
				submitAll: commitPackage
				for: session id
				beginAnother: false) ;
		decrementTransactionLevel! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 4/3/2003 23:00'!
getDefinition

	^session materializeObject: repository definitionByteArray! !

!MagmaRepositoryController methodsFor: 'initializing' stamp: 'cmm 1/16/2005 18:45'!
initialize

	super initialize.
	self initializeSession.
	session initializeDefinition.
	session definition addMinimumClassesForOdbmsUsing: self serverSerializer.
	requestInterruptGuard _ Semaphore forMutualExclusion.
	isReadOnly _ false! !

!MagmaRepositoryController methodsFor: 'initializing' stamp: 'cmm 3/27/2002 22:00'!
initializeServerSerializer
	"Why is this separate, 'serverSerializer' needed?  Because the session serializer requires a different traversalStrategy.  The serverSerializer needs to be able to fully serialize, to the ends of the graphs, the 'response' objects of various requests."

	serverSerializer _ self session serializer copyWithNewBuffer initializeTraversalStrategy
! !

!MagmaRepositoryController methodsFor: 'initializing' stamp: 'cmm 1/16/2005 18:45'!
initializeSession

	session _ MagmaSession repositoryController: self.
	self initializeServerSerializer! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 9/1/2003 19:40'!
initializeSystemReadStrategy

	repository initializeSystemReadStrategyUsing: self serverSerializer classIdManager! !

!MagmaRepositoryController methodsFor: 'accessing' stamp: 'cmm 4/30/2003 22:07'!
isOpen

	^repository isOpen! !

!MagmaRepositoryController methodsFor: 'security' stamp: 'cmm 12/17/2002 14:45'!
isReadOnly

	^isReadOnly! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 12/26/2004 22:38'!
largeCollectionManagerFor: collectionOidInteger

	^ repository largeCollectionManagers at: collectionOidInteger! !

!MagmaRepositoryController methodsFor: 'accessing' stamp: 'cmm 1/14/2005 16:05'!
magmaId

	^ self definition magmaId! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 6/14/2004 18:13'!
materializeClassDefinitions
	"This is needed because, when opening the repository, the default classes do not include MagmaRepositoryDefinition, which is delivered as part of any session-connection.  When the system-session attempts to connect, it tries to read the repository-definition but can't because it can't get a proper read-strategy for it."

	session loadClassDefinitionsFrom: repository classDefinitionsByteArray! !

!MagmaRepositoryController methodsFor: 'unsupported' stamp: 'cmm 5/2/2004 20:40'!
maximumNumberOfChallengers: anInteger 
	self session 
		commit: [ self definition maximumNumberOfChallengers: anInteger ]! !

!MagmaRepositoryController methodsFor: 'client requests' stamp: 'cmm 1/16/2005 21:47'!
newSessionFor: userIdString

	^ repository
		newSessionFor: userIdString
		numberOfChallengers: MagmaRepositoryDefinition defaultMaximumNumberOfChallengers! !

!MagmaRepositoryController methodsFor: 'client requests' stamp: 'cmm 12/26/2004 21:12'!
newTransactionFor: sessionId

	| refreshViewResult |
	isReadOnly ifTrue:
		[ MagmaUserError signal: 'This repository is set to read-only, commits are prohibited.' ].
	refreshViewResult _ repository newTransactionFor: sessionId.
	^ refreshViewResult! !

!MagmaRepositoryController methodsFor: 'statistics' stamp: 'cmm 5/2/2003 14:56'!
numberOfConnectedClients

	^repository sessions size - 1! !

!MagmaRepositoryController methodsFor: 'client requests' stamp: 'cmm 5/1/2002 22:55'!
numberOfEntriesFrom: lowKeyInteger to: highKeyInteger inLargeCollection: collectionOid on: attributeSymbol

	| index |

	index _
		(self largeCollectionManagerFor: collectionOid)
			indexForAttribute: attributeSymbol
			ifNone:
				[ MagmaSoftwareError signal:
					attributeSymbol , ' is not an index of large-collection with oid ' ,
						collectionOid printString , '.' ].
	^index
		numberOfEntriesFrom: lowKeyInteger
		to: highKeyInteger
! !

!MagmaRepositoryController methodsFor: 'statistics' stamp: 'cmm 4/21/2003 15:55'!
objectCount
	"Answers how many objects have been committed to this repository.  Does not account for objects that have since been garbage colellected."

	^repository objectCount! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 9/24/2004 13:38'!
open
	"This is called when restarting controllers during image restart."

	self
		privateOpen: directory ;
		openLargeCollections! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 9/24/2004 13:32'!
open: aFileDirectory

	OpenControllers add: self. "<- we only do this for intentional opens, not image restarts"
	directory _ aFileDirectory.
	self open! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 12/26/2004 22:38'!
openLargeCollection: aMagmaCollection

	repository openLargeCollectionIfNecessary: aMagmaCollection
! !

!MagmaRepositoryController methodsFor: 'initializing' stamp: 'cmm 5/2/2004 20:40'!
openLargeCollections
	"Open all indexes for all large collections."

	self definition allLargeCollections 
		do: [ :each | self openLargeCollection: each ]! !

!MagmaRepositoryController methodsFor: 'client requests' stamp: 'cmm 9/24/2004 15:13'!
pathName

	^ directory pathName! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 6/29/2004 23:46'!
primClose

"Here, it should shutdown gracefully, but any queued requests will not be processed.  Once VI4 is available, we can uncomment the version below for more grace."
	self requestCritical:
		[ session disconnect.
		repository close ].

self maMarked: 'dev'.
"once we get block-closures, we should be able to safely close the repository using the code below.  The code below utilizes the existing client server framework's request queueing to ensure all pending requests are processed before we close, ensuring everyones work gets saved.  Unfortunately, it requires a double-evaluation of the processBlock.  Until then, you'll have to exercise your best judgement."


	"go through the session to close the repository so we ensure all pending requests are processed."
"
	[ session closeRepository ] fork.
	[ self isOpen ] whileTrue: [ (Delay forSeconds: 1) wait ]
"! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 2/20/2005 16:27'!
privateOpen: aFileDirectory

	MagmaNotification signal: 'opening Magma repository ', self pathName.
	self
		initializeSession;
		repository: (
			MaObjectRepository
				open: aFileDirectory
				controller: self) ;
		initializeSystemReadStrategy ;
		materializeClassDefinitions ;
		connect ;
		refreshView "so more classes will be pulled from unusedDepths of the SystemReadStrategy"! !

!MagmaRepositoryController methodsFor: 'client/server required methods' stamp: 'cmm 1/14/2005 00:05'!
processRequest: aMaRepositoryRequest

	aMaRepositoryRequest repositoryController: self.
	^[ aMaRepositoryRequest sessionId = self sessionId
		ifTrue: [ aMaRepositoryRequest process ]
		ifFalse: [ self requestCritical: [ aMaRepositoryRequest process ] ] ]

		on: MaError
		do: 
			[ :anError |
			(MagmaPreferences debug
				and: [ anError class ~= MagmaCommitError ])
					ifTrue: [ self halt: anError messageText ].
			anError ]! !

!MagmaRepositoryController methodsFor: 'client/server required methods' stamp: 'cmm 9/1/2003 15:15'!
protocol

	| answer |

	answer _ self class protocol asOrderedCollection.
	answer addAll: MaIndexDefinition allSubclasses.
	(Smalltalk hasClassNamed: #MagmaTestCase)
		ifTrue: [ answer addAll: (Smalltalk at: #MagmaTestCase) additionalProtocolForRepositoryController ].
	^answer
! !

!MagmaRepositoryController methodsFor: 'client requests' stamp: 'cmm 1/25/2005 15:55'!
read: oidInteger for: sessionId using: aMaReadStrategy

	| result |
	result _ MaReadResult byteArray:
		(repository
			byteArrayAt: oidInteger
			using:
				(self 
					ensureReadStrategy: aMaReadStrategy
					forSession: sessionId)).
	repository
		renewServerNotificationsIn: result
		for: sessionId.
	^result! !

!MagmaRepositoryController methodsFor: 'client requests' stamp: 'cmm 2/9/2005 10:42'!
readAnchorFor: sessionId using: aMaReadStrategy

	| result |
	result _ MaReadResult byteArray:
		(repository anchorByteArrayUsing: 
			(self 
				ensureReadStrategy: aMaReadStrategy
				forSession: sessionId)).
	repository
		renewServerNotificationsIn: result
		for: sessionId.
	^result! !

!MagmaRepositoryController methodsFor: 'client requests' stamp: 'cmm 9/1/2003 19:21'!
refreshView

	self session abort.
	repository systemReadStrategy makeReadyForUseUsing: session serializer classIdManager! !

!MagmaRepositoryController methodsFor: 'private' stamp: ''!
repository

	^repository
! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 12/31/2002 12:54'!
repository: aMaObjectRepository

	repository _ aMaObjectRepository.
	aMaObjectRepository repositoryController: self! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 12/27/2002 15:55'!
requestCritical: aBlock
	"Coordinate access to all server elements."

	^requestInterruptGuard critical: aBlock! !

!MagmaRepositoryController methodsFor: 'private' stamp: ''!
serverSerializer
	"The serverSerializer is used for processing client requests.  It is also
	used during administration and possibly needed during initial creation of a
	repository."

	^serverSerializer
! !

!MagmaRepositoryController methodsFor: 'private' stamp: ''!
session
	"The server-side session is needed for largeCollection updates to be
	processed correctly.  When a client makes a change to a largeCollection, such
	as adding or removing an index, the systemRoot change is reflected upon
	the servers session refreshing its view of the database."

	^session
! !

!MagmaRepositoryController methodsFor: 'accessing' stamp: 'cmm 4/3/2003 22:59'!
sessionId

	^session id
! !

!MagmaRepositoryController methodsFor: 'client requests' stamp: 'cmm 10/22/2002 23:18'!
signalRequestGuard

	requestInterruptGuard signal! !

!MagmaRepositoryController methodsFor: 'client requests' stamp: ''!
sizeOfLargeCollection: oidInteger

	^(self largeCollectionManagerFor: oidInteger) size
! !

!MagmaRepositoryController methodsFor: 'client requests' stamp: 'cmm 12/26/2004 22:38'!
submitAll: aMaCommitPackage for: sessionId beginAnother: aBoolean

	^ repository
		submitAll: aMaCommitPackage
		for: sessionId
		beginAnother: aBoolean! !

!MagmaRepositoryController methodsFor: 'client requests' stamp: 'cmm 1/28/2005 00:10'!
upTo: anInteger oidsFrom: lowKey to: highKey inLargeCollection: collectionOid on: attributeSymbol using: aMaReadStrategy forSession: sessionId

	| segmentResult |

	segmentResult _ (self largeCollectionManagerFor: collectionOid)
		upTo: anInteger
		inSegmentFrom: lowKey
		to: highKey
		on: attributeSymbol.
	segmentResult
		objects:
			(segmentResult objects collect:
				[ :each | 
				repository
					byteArrayAt: each
					using:
						(self 
							ensureReadStrategy: aMaReadStrategy
							forSession: sessionId) ]).
	repository
		renewServerNotificationsIn: segmentResult
		for: sessionId.
	^ segmentResult! !

!MagmaRepositoryController methodsFor: 'client requests' stamp: 'cmm 1/28/2005 00:09'!
upTo: anInteger oidsFromIndex: startIndex inLargeCollection: collectionOid on: attributeSymbol using: aMaReadStrategy forSession: sessionId

	| segmentResult |

	segmentResult _ (self largeCollectionManagerFor: collectionOid)
		upTo: anInteger
		inSegmentFromIndex: (startIndex max: 1)
		on: attributeSymbol.
	segmentResult
		objects:
			(segmentResult objects collect:
				[ :each | 
				repository
					byteArrayAt: each
					using:
						(self 
							ensureReadStrategy: aMaReadStrategy
							forSession: sessionId) ]).
	repository
		renewServerNotificationsIn: segmentResult
		for: sessionId.
	^ segmentResult! !

!MagmaRepositoryController methodsFor: 'client/server required methods' stamp: 'cmm 9/19/2004 22:08'!
value: aMagmaRepositoryRequest

	^ self processRequest: aMagmaRepositoryRequest! !

!MagmaRepositoryController methodsFor: 'statistics' stamp: 'cmm 4/21/2003 16:02'!
version

	^repository version! !

MaObject subclass: #MagmaServerStatistics
	instanceVariableNames: 'startTime stopTime socketsQueuedStat requestsQueuedStat requestSizeStat requestProcessingTimeStat responseSizeStat stopwatch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-API'!

!MagmaServerStatistics methodsFor: 'counting' stamp: 'cmm 11/16/2004 21:49'!
decrementRequestsQueued

	requestsQueuedStat last: requestsQueuedStat last - 1! !

!MagmaServerStatistics methodsFor: 'counting' stamp: 'cmm 11/16/2004 21:50'!
decrementSocketsQueued

	socketsQueuedStat last: socketsQueuedStat last - 1! !

!MagmaServerStatistics methodsFor: 'counting' stamp: 'cmm 11/16/2004 21:47'!
incrementRequestsQueued

	requestsQueuedStat addValue: 1 + requestsQueuedStat last! !

!MagmaServerStatistics methodsFor: 'counting' stamp: 'cmm 11/16/2004 21:47'!
incrementSocketsQueued

	socketsQueuedStat addValue: socketsQueuedStat last + 1! !

!MagmaServerStatistics methodsFor: 'initializing' stamp: 'cmm 11/16/2004 21:50'!
initialize
	super initialize.
	stopwatch _ MaStopwatch new.
	socketsQueuedStat _ MaStat new last: 0.
	requestsQueuedStat _ MaStat new last: 0.
	requestSizeStat _ MaStat new last: 0.
	requestProcessingTimeStat _ MaStat new last: 0.
	responseSizeStat _ MaStat new last: 0! !

!MagmaServerStatistics methodsFor: 'printing' stamp: 'cmm 2/5/2003 16:29'!
printOn: aStream

	super printOn: aStream.
	aStream
		cr; tab;
		nextPutAll: 'sockets queued: ';
		maPrintAbbreviated: socketsQueuedStat;
		cr; tab;
		nextPutAll: 'requests queued:  ';
		maPrintAbbreviated: requestsQueuedStat;
		cr; tab;
		nextPutAll: 'request sizes:  ';
		maPrintAbbreviated: requestSizeStat;
		cr; tab;
		nextPutAll: 'request processing time:  ';
		maPrintAbbreviated: requestProcessingTimeStat;
		cr; tab;
		nextPutAll: 'response sizes:  ';
		maPrintAbbreviated: responseSizeStat! !

!MagmaServerStatistics methodsFor: 'counting' stamp: 'cmm 11/16/2004 10:51'!
recordRequestSize: anInteger

	requestSizeStat addValue: anInteger! !

!MagmaServerStatistics methodsFor: 'counting' stamp: 'cmm 11/16/2004 10:51'!
recordResponseSize: anInteger

	responseSizeStat addValue: anInteger! !

!MagmaServerStatistics methodsFor: 'accessing' stamp: 'cmm 1/27/2004 16:20'!
requestProcessingTimeStat

	^requestProcessingTimeStat! !

!MagmaServerStatistics methodsFor: 'accessing' stamp: 'cmm 1/27/2004 16:20'!
requestSizeStat

	^requestSizeStat! !

!MagmaServerStatistics methodsFor: 'accessing' stamp: 'cmm 1/27/2004 16:20'!
requestsQueuedStat

	^requestsQueuedStat! !

!MagmaServerStatistics methodsFor: 'accessing' stamp: 'cmm 1/27/2004 16:20'!
responseSizeStat

	^responseSizeStat! !

!MagmaServerStatistics methodsFor: 'accessing' stamp: 'cmm 1/27/2004 16:20'!
socketsQueuedStat

	^socketsQueuedStat! !

!MagmaServerStatistics methodsFor: 'actions' stamp: 'cmm 1/5/2003 22:57'!
startRequestTimer

	stopwatch reset; start! !

!MagmaServerStatistics methodsFor: 'accessing' stamp: 'cmm 7/1/2004 00:34'!
startTime

	^ startTime! !

!MagmaServerStatistics methodsFor: 'accessing' stamp: 'cmm 10/6/2002 23:23'!
startTime: aMaCalendarTime

	startTime _ aMaCalendarTime! !

!MagmaServerStatistics methodsFor: 'actions' stamp: 'cmm 11/16/2004 10:52'!
stopRequestTimer

	stopwatch stop.
	requestProcessingTimeStat addValue: stopwatch time! !

!MagmaServerStatistics methodsFor: 'accessing' stamp: 'cmm 7/1/2004 00:34'!
stopTime

	^ stopTime! !

!MagmaServerStatistics methodsFor: 'accessing' stamp: 'cmm 10/7/2002 00:33'!
stopTime: aMaCalendarTime

	stopTime _ aMaCalendarTime! !

MaRequestServerConsole subclass: #MagmaServerConsole
	instanceVariableNames: 'server controller statistics'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-API'!

!MagmaServerConsole methodsFor: 'accessing' stamp: 'cmm 12/18/2002 21:52'!
controller

	^controller! !

!MagmaServerConsole methodsFor: 'initializing' stamp: 'cmm 12/24/2002 15:50'!
initialize
	super initialize.
	statistics := MagmaServerStatistics new! !

!MagmaServerConsole methodsFor: 'notifications' stamp: 'cmm 1/4/2003 17:17'!
note: stringMessage

	Transcript cr; show: stringMessage! !

!MagmaServerConsole methodsFor: 'notifications' stamp: 'cmm 1/5/2003 22:56'!
noteProcessingRequest: yourRequestObject

	statistics startRequestTimer! !

!MagmaServerConsole methodsFor: 'notifications' stamp: 'cmm 1/5/2003 22:53'!
noteRequestDequeued: requestByteArray for: aSocket
	"Indicates aSocket has delivered a ByteArray request that is about to be processed by my server."

	statistics decrementRequestsQueued! !

!MagmaServerConsole methodsFor: 'notifications' stamp: 'cmm 2/4/2003 12:36'!
noteRequestProcessed: requestObject

	statistics stopRequestTimer! !

!MagmaServerConsole methodsFor: 'notifications' stamp: 'cmm 1/5/2003 22:44'!
noteRequestQueued: aByteArray for: aSocket
	"Indicates aSocket has delivered aByteArray as a request that it wants processed and the response returned."

	statistics
		incrementRequestsQueued;
		recordRequestSize: aByteArray size! !

!MagmaServerConsole methodsFor: 'notifications' stamp: 'cmm 2/4/2003 13:09'!
noteResponseSent: aByteArray to: aSocket
	"Successfully sent the aByteArray to aSocket."

	statistics recordResponseSize: aByteArray size! !

!MagmaServerConsole methodsFor: 'notifications' stamp: 'cmm 4/30/2003 17:44'!
noteServerShutdown

	controller close.
	statistics stopTime: MaCalendarTime now.
	self note: controller printString, ' closed.'! !

!MagmaServerConsole methodsFor: 'notifications' stamp: 'cmm 1/5/2003 18:19'!
noteSocketDequeued: aSocket

	statistics decrementSocketsQueued! !

!MagmaServerConsole methodsFor: 'notifications' stamp: 'cmm 10/7/2002 22:06'!
noteSocketQueued: aSocket

	statistics incrementSocketsQueued! !

!MagmaServerConsole methodsFor: 'start / stop' stamp: 'cmm 2/20/2005 19:39'!
open: pathName processOn: portInteger

	controller _ MagmaRepositoryController open: pathName.
	server _ (MaTcpRequestServer protocol: controller protocol) console: self.
	statistics startTime: MaCalendarTime now.
	server 
		processOn: portInteger
		using: [ :eachRequest | controller processRequest: eachRequest ].
	^self! !

!MagmaServerConsole methodsFor: 'start / stop' stamp: 'cmm 12/17/2002 14:44'!
openReadOnly: fileNameString processOn: portInteger

	self
		open: fileNameString
		processOn: portInteger.
	controller beReadOnly! !

!MagmaServerConsole methodsFor: 'accessing' stamp: 'cmm 2/22/2005 13:13'!
server

	^ server! !

!MagmaServerConsole methodsFor: 'start / stop' stamp: 'cmm 10/7/2002 00:42'!
shutdown

	server shutdown! !

!MagmaServerConsole methodsFor: 'accessing' stamp: 'cmm 1/27/2004 15:55'!
statistics

	^statistics! !

!MaBasicReadStrategy methodsFor: '*magma server' stamp: 'cmm 1/26/2005 17:28'!
depthOfAttribute: attributeIndex onClassWithId: classId version: versionNumber
	"Answer the delta-depth from the current depth to read.  This is distinct from my minimumDepth, which was used at the start of this graph-read."

	^ 0! !

!MaOidCalculator class methodsFor: '*magma server' stamp: 'cmm 12/2/2004 13:44'!
indexPositionForOid: anInteger

	^ anInteger - self firstUserObjectOid! !

!MaOidCalculator class methodsFor: '*magma server' stamp: 'cmm 8/13/2002 23:57'!
isOidForOptimizedObject: oidInteger
	"Answer whether oidInteger is an oid for anObject which will never require its own buffer.  These include optimized Integers, nil, true, false, and all Characters."

	^(self isOidForNewObject: oidInteger) not
		and: [ (self isOidForUserObject: oidInteger) not ]! !

!MaOidCalculator class methodsFor: '*magma server' stamp: 'cmm 11/13/2002 23:05'!
isOidForUserObject: anInteger
	"A 'user' object is a persistent object stored in a Magma database that does not have a special oid, such as SmallIntegers, Floats, Booleans, etc. have."

	^anInteger
		between: self firstUserObjectOid
		and: self lastUserObjectOid! !

!MaOidCalculator class methodsFor: '*magma server' stamp: 'cmm 8/13/2002 23:54'!
lastUserObjectOid

	^18446744067266100672   "self oidForSmallestFloat - 1"! !

!MaOidCalculator class methodsFor: '*magma server' stamp: 'cmm 12/2/2004 13:32'!
oidForFilePositionIndexPosition: anInteger

	^ self firstUserObjectOid + anInteger! !

!MaByteObjectBuffer methodsFor: '*magma server' stamp: 'cmm 1/25/2005 14:07'!
appendGraphUsing: aMaReadStrategy into: aMaSerializedGraphBuffer currentDepth: currentDepth minDepth: minDepth with: alreadyAppendedSet filer: aMaObjectFiler

	"Nothing to do for a byte-object."
! !

!MagmaSession class methodsFor: '*magma server-private' stamp: 'cmm 2/8/2005 21:44'!
newLocalLinkFor: aMagmaRepositoryController

	^ MaLocalServerLink localRequestServer: (MaLocalRequestServer processor: aMagmaRepositoryController)! !

!MagmaSession class methodsFor: '*magma server' stamp: 'cmm 10/26/2004 12:48'!
openLocal: pathString

	^ self repositoryController: (MagmaRepositoryController openedOn: pathString)! !

!MagmaSession class methodsFor: '*magma server' stamp: 'cmm 12/26/2004 23:21'!
repositoryController: aMagmaRepositoryController
	"Use this constructor only for *additional* local connections, i.e., two or more sessions connected to the same local repository.  Use the same MagmaRepositoryController you used to create the original."

	^ self link: (self newLocalLinkFor: aMagmaRepositoryController)! !

!MagmaSession methodsFor: '*magma server' stamp: 'cmm 2/15/2005 10:51'!
ensureOpen

	self isLocal ifFalse: [ MagmaUserError signal: 'Only available for local connections.' ].
	self isOpen ifFalse:
		[ self link: (self class newLocalLinkFor: (MagmaRepositoryController openedOn: self pathName)) ]! !

!MagmaSession methodsFor: '*magma server' stamp: 'cmm 1/13/2005 18:01'!
isOpen
	^ self isRemote 
	or: [ "local" self repositoryController isOpen ]! !

!MagmaSession methodsFor: '*magma server' stamp: 'cmm 1/13/2005 18:01'!
repositoryController

	^ link localRequestServer processor! !

PackageInfo subclass: #MagmaServerPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma server-Info'!

!MagmaServerPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 10/31/2004 23:42'!
changesText

	^'
1.0gamma8
	- removed "allowNewClasses" feature.  This will be handled with real security later.
	- all administration functions are now either remote requests or no longer needed.
	- support for first-class MagmaRepositoryCodeBase.

1.0gamma7
	- Compatible with Squeak 3.7.
	- Better support for Symbols (thanks to Brent Pinkney!!).
	- fix for storing Exceptions in the repository (to accommodate changes in Squeak 3.6).
	- New Date index type for MagmaCollections.
	- New Float index type for MagmaCollections.
	- MagmaSessions cleaned from MethodContext receivers, allowing full garbage collection (thanks to Giovanni!!).
	- Critical bugs with MagmaCollections fixed and now pass the new, extra-stringent tests in the Tester package.
	
1.0gamma6
	- works with Squeak 3.6.  Doesn''t work with versions before 3.6.
	- fixed issue with servers that were running when the image was saved (functionality implemented in 1.0gamma5).  Fixed similar bug for saving with open local repository connections.
	- disconnect now cleans up the proxies for that session.  Please be patient, this can take a while if you have a lot.  Also now cleaning dynamic largeCollection attributes when disconnecting a session.
	- fixed bug with creating repository using an unqualified file name.
	- fixed an unnoticed reference to platform-specific code (ByteArray>>unsignedByteAt: uses FFI primitives).
	- improved the internal system-read-strategy.


1.0gamma5
	- Servers and clients can now survive image restarts.
	- added a new session preference (see MagmaPreferences), "signalProxyMaterialization" so you can capture MagmaNotifications and fine-tune your read strategies.
	- Another performance improvement!!  ReadStrategies are now cached on the server, instead of in your MagmaSession, improving read-efficiency when using read strategies because the strategy-object no longer needs to be serialized and transported for every proxy materialization.  Additionally, ReadStrategies for classes that don''t exist in the repository are no longer dropped.  Instead, they are remembered until you put those classes into the repository.
	- commit conflicts no longer provide the entire MagmaClientConnection object who conflicted with your session, just the userId.  This is due to the aforementioned cached readStrategy, no need to be sending that down on a commit conflict.
	- Since we have eradicated the "root trap" we can make replacing the root consistent with other Magma changes.  A transaction is now required.
	- several bug fixes.
'! !

!MagmaServerPackageInfo methodsFor: 'accessing' stamp: 'cmm 4/8/2004 21:30'!
prerequisitePackages
	^ #( 'Magma client' 'Ma time objects' )! !

!MagmaServerPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 2/4/2003 18:12'!
readmeText

	^'This package is used to host a Magma repository.  For more information visit http://minnow.cc.gatech.edu/squeak/2665.'! !
MagmaRepositoryController initialize!
